<?php
/**
 * @package WSN Knowledge Base for Wordpress
 * @version 1.3.9
 */
/*
Plugin Name: WSN Knowledge Base for Wordpress
Plugin URI: https://www.wsnkb.com
Description: A PHP/MySQL article directory script for content marketing.
Author: Paul Knierim
Version: 1.3.9
Author URI: https://www.webmastersite.net
*/
$autosetupversion = '1.3.9';
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL & ~E_NOTICE & ~E_STRICT & ~E_DEPRECATED);

if (function_exists('register_activation_hook')) $inwordpress = true; else $inwordpress = false;

if ($inwordpress)
{ // we're inside wordpress. conditionaled so we can debug easier when not.
 register_activation_hook(__FILE__, 'wsnkb_activate');
 register_deactivation_hook(__FILE__, 'wsnkb_deactivate');
 register_uninstall_hook(__FILE__, 'wsnkb_uninstall');
 add_filter('wp_nav_menu_items','wsnkb_addlinktomenu', 10, 2);
//add_action('init', 'wsnkb_test');
// these two lines make the wordpress toolbar show up on the wsn side:
 add_action( 'init', 'wsnkb_wpse240134_wp_admin_bar_init' );
 function wsnkb_wpse240134_wp_admin_bar_init() { _wp_admin_bar_init(); }
 add_shortcode('wsnkbtoplist', 'wsnkb_toplistshortcode');
 add_action( 'admin_menu', 'wsnkb_addadminmenupage' );
/*This bit makes sure wsn login cookies are always set when we're logged in to wordpress. note that this makes logging out from wsn impossible, must logout from wordpress, but that's okay i think since theme is integrated? */
add_action('init', 'wsnkb_checkwsnlogincookies'); // this way we don't have situations like newly registered people not being logged in to wsn until they login to wordpress even though they're already logged in automatically via their registration
add_action('wp_login', 'wsnkb_setwsnlogincookies', 10, 1);
add_action('wp_logout', 'wsnkb_unsetwsnlogincookies', 10, 0);
add_action('admin_notices', 'wsnkb_activationnoticefunc');
}

// to adapt to other wsn script, replace all instances of wsnkb_ with wsngallery_ etc. prefixes ensure no function conflict

//Debugging aides to see/record output:

//function wsnkb_tl_save_error() { update_option( 'plugin_error',  ob_get_contents() ); }
//add_action('activated_plugin', 'wsnkb_tl_save_error');
//echo get_option('plugin_error'); // to display the error message
/* Or you could do the following: */
//file_put_contents('/var/www/html/testing/1wordpresserrors.txt', ob_get_contents());


//require_once 'wp-admin/includes/plugin.php';


//wsnkb_fixbadprefix(); // this caused an empty needle error, hopefully not needed by anyone anymore
if ($inwordpress && !file_exists(wsnkb_uploadpath())) wsnkb_updateonmove(); // check if it still exists at same location or dir may have been renamed


function wsnkb_activationnoticefunc()
{
 global $wsnscripttitle;
 wsnkb_setvars();
 if (get_transient('wsnkb_activationnotice'))
 {
  $installurl = wsnkb_dirurl();
  echo "<div class=\"updated notice is-dismissible\"><p>$wsnscripttitle is now active at <a href=\"$installurl\">$installurl</a>. Please link it where you want to in your wordpress theme.</p></div>";
  delete_transient('wsnkb_activationnotice');
 }
}

function wsnkb_useridcookiename()
{ // new installs all use wsnuser, but pre-1.3.9 used wsnuser... so, detect if we predate that somehow? or query the wsn installation if we can... if wsn installation doesn't exist yet then we can assume the new version
 global $defaultscript, $wpdb;
 wsnkb_setvars();
 $r = $wpdb->get_row("SELECT * FROM ".wsnkb_installedprefix()."settings WHERE name='cookienameuserid");
 $ret = $mylink->content; //prints "10"
 if (!$ret) $ret = 'wsnuserwp';
 return $ret;
}

function wsnkb_passcookiename()
{
 global $defaultscript, $wpdb;
 wsnkb_setvars();
 $r = $wpdb->get_row("SELECT * FROM ".wsnkb_installedprefix()."settings WHERE name='cookienamepass");
 $ret = $mylink->content; //prints "10"
 if (!$ret) $ret = "wsnpasswp";
 return $ret;
}

function wsnkb_setwsnlogincookies($user)
{
 global $wpdb, $wsninfo;
 $id = $user->ID;
 $hash = $wpdb->get_var( "SELECT user_pass FROM ".$wpdb->users." WHERE ID=$id" );
 if ($_REQUEST['rememberme']) $expiration = time()+86400*365*7; // 7 years
 else $expiration = 0; // session only
 // all the wsns will have the same (wordpress-sourced) logins, so it's okay that e.g. links and gallery share same cookies
 setcookie(wsnkb_useridcookiename(), $id, $expiration, "/", wsnkb_cookiedomain());
 setcookie(wsnkb_passcookiename(), $hash, $expiration, "/", wsnkb_cookiedomain());
}

function wsnkb_unsetwsnlogincookies()
{
 global $wsninfo;
 $expiration = time() - 86400*365; // last year
 setcookie(wsnkb_useridcookiename(), "", $expiration, "/", wsnkb_cookiedomain());
 setcookie(wsnkb_passcookiename(), "", $expiration, "/", wsnkb_cookiedomain());
}

function wsnkb_checkwsnlogincookies()
{
 $u = wsnkb_useridcookiename(); $p = wsnkb_passcookiename();
 if ((!isset($_COOKIE[$u]) || !$_COOKIE[$p]) && is_user_logged_in()) wsnkb_setwsnlogincookies(wp_get_current_user());
}

function wsnkb_toplistshortcode($atts = [], $content = null)
{ // display WSN toplists inside wordpress. the entire toplist is the shortcode content.
// limitiations: live toplists and paginated toplists (particularly ajax pagination) not yet supported
if (!$content) return $content;
$params = 'action=wptoplist&toplistcontent='.urlencode($content);
//to get url to test: file_put_contents("/var/www/html/1.txt", wsnkb_dirurl().'/ajax.php?action=wptoplist&toplistcontent='.urlencode($content));
$result = wsnkb_sendpost(wsnkb_dirurl().'/ajax.php', $params);
if ($result) $content = htmlspecialchars_decode($result);
return $content; // always return
}

function wsnkb_cookiedomain()
{ // use sub.domain.com or (if sub is blank or www) .domain.com as cookie path so that we don't have www vs. non-www login issues
 $url = get_site_url();
 $parts = explode('://', $url);
 $url = rtrim($parts[1], '/');
 if (strstr($url, '/'))
 {
  $parts = explode('/', $url);
  $url = $parts[0];
 }
 $domain = str_replace('www.', '', $url);
 if (substr_count($domain, '.') < 2) $domain = '.'.$domain;
 return $domain;
}

function wsnkb_addadminmenupage()
{
 global $scriptname, $defaultscript, $brandprefix, $thisfilename, $wsninstalltitle;
 wsnkb_setvars();
 $slug = preg_replace('/[^a-z]/', '', strtolower($wsninstalltitle)).'admin';
 add_menu_page($wsninstalltitle, $wsninstalltitle, 'manage_options', 'wsnkbforwordpress', 'wsnkb_admin_page', 'none', 6  );
}

function wsnkb_getdbdata($name)
{
 $sp = 'wsnkb_';
 return get_option($sp.$name);
}

function wsnkb_setdbdata($name, $value)
{
 $sp = 'wsnkb_';
 return update_option($sp.$name, $value, true);
}

function wsnkb_admin_page()
{
 global $scriptname, $defaultscript, $brandprefix, $thisfilename, $wsninstalltitle;
 wsnkb_setvars();
	echo '
	<style>
	#wpbody, #wpcontent, #adminmenuwrap, #wpbody-content, #wpwrap { height: 95%; }
	body { margin: 0; padding: 0; overflow: hidden; }
    .wsnframe { height: 100%; width: 100%; padding: 0; margin: 0; border: 0; }
    #wpfooter { opacity: 1; background-color: #CCCCCC; }
	</style>
	<div class="wrap" style="height: 100%;">
	<iframe src="'.wsnkb_dirurl().'/wsnadmin/index.php" class="wsnframe"></iframe>
	</div>
	';
}

function wsnkb_installedpath()
{
 return wsnkb_getdbdata('wsninstalledpath');
}

function wsnkb_installedprefix()
{
 return wsnkb_getdbdata('wsninstalledprefix');
}

function wsnkb_pluginisactive()
{
 return wsnkb_getdbdata('wsnactive');
}

function wsnkb_deactivate()
{ // remove link from wordpress menu and set wsn setting to 'closed for maintenance'
  global $defaultscript, $wpdb;
  wsnkb_setvars();
  wsnkb_setdbdata('wsnactive', 0);
  $wpdb->query("UPDATE ".wsnkb_installedprefix()."settings SET content='yes' WHERE name='offline'");
  $wpdb->query("UPDATE ".wsnkb_installedprefix()."settings SET content='Deactivated for the time being, check back later.' WHERE name='offlinereason'");

  wsnkb_deletemenuitem();

}

function wsnkb_uninstall()
{ // completely remove files and database
 global $wpdb, $alltables;
 wsnkb_setvars();
 $path = wsnkb_installedpath();
 $prefix = wsnkb_installedprefix();
 if (!$path || !$prefix) die("Error: no installation was recorded, so can't uninstall!");
 reset($alltables);
 foreach($alltables as $t)
 {
  if (strstr($t, $prefix)) $removetables[] = $t;
 }
 foreach($removetables as $r)
 {
  $wpdb->query("DROP TABLE `$r`");
 }
 $sp = 'wsnkb_';
 delete_option($sp.'wsnactive');
 delete_option($sp.'wsninstalledpath');
 delete_option($sp.'wsninstalledprefix');
 wsnkb_removedirectory($path);
}

function wsnkb_activate()
{
 global $defaultscript, $defaultseries, $wpdb, $thisfilename;
 wsnkb_setvars();
 $test = wsnkb_servercheck();
 if (strstr($test, 'failed')) die($test);
 if (!wsnkb_installedprefix() || !file_exists(wsnkb_uploadpath()))
 {
  if (wsnkb_allowed_bytes() < 50000000) @ini_set("memory_limit", "64M"); // probably not allowed, but try to allow more memory for phar extraction
  error_reporting(E_ALL & ~E_NOTICE & ~E_STRICT & ~E_DEPRECATED);
  set_error_handler('wsnkb_errorhandler');
  register_shutdown_function('wsnkb_shutdown');
  @umask(022);
  if (wsnkb_functionwillwork('set_time_limit')) @set_time_limit(190);

  $prefix = wsnkb_getdbprefix(); // need it up here because this looks for the next unused value, which will be changed after installation
  $path = wsnkb_uploadpath(); // not strictly needed before installit, but may as well keep these lines togeather
  wsnkb_installit(); // works now! to simplify, integration will be handled by wsn's setup.php file when wordpressprefix is passed.
  wsnkb_setdbdata('wsninstalledpath', $path);
  wsnkb_setdbdata('wsninstalledprefix', $prefix);
  set_transient('wsnkb_activationnotice', true, 5);
 }
 else
 {
  // already installed. record rectivation so it shows on menu again if it was disabled.
  wsnkb_setdbdata('wsnactive', 1);
  // and also make sure the wsn isn't set to offline anymore
  $wpdb->query("UPDATE ".wsnkb_installedprefix()."settings SET content='no' WHERE name='offline'");
  set_transient('wsnkb_activationnotice', true, 5);
 }
 wsnkb_addmenuitem(); // uncomment once it works
}

function wsnkb_updateonmove()
{ // update the installed path if they renamed it
  global $wpdb;
  wsnkb_setvars();
  if (!wsnkb_installedprefix()) return false; // must not be installed yet
  $oldurl = wsnkb_dirurl();
  $result = $wpdb->get_results("SELECT content FROM ".wsnkb_installedprefix()."settings WHERE name='uploadpath'", ARRAY_N);
  $n = count($result);
  if ($n) { $path = str_replace('/attachments/', '/', $result[0][0]); }

  if ($path) wsnkb_setdbdata('wsninstalledpath', $path); // updates

  // we should also try to update the menu link!
 /*
 $locations = get_theme_mod('nav_menu_locations');
 if (isset($locations['top']) && $locations['top']) $topmenu = $locations['top'];
 else if (isset($locations['primary']) && $locations['primary']) $topmenu = $locations['primary'];
 else $topmenu = false;

 if ($topmenu)
 {
  $menu_id = wp_get_nav_menu_object($topmenu);
  $menu_items = wp_get_nav_menu_items($menu_id);
  foreach ($menu_items as $menu_item)
  {
   if ($menu_item->menu_item_parent == 0)
   {
    if ($menu_item->url == $oldurl.'/')
    {
     $menu_item->url = wsnkb_dirurl();
     $menu_item->how do we save changes?
    }
   }
  }
 }
 */
}

function wsnkb_deletemenuitem()
{
 wsnkb_setvars();
 $locations = get_theme_mod('nav_menu_locations');
 if (isset($locations['top']) && $locations['top']) $topmenu = $locations['top'];
 else if (isset($locations['primary']) && $locations['primary']) $topmenu = $locations['primary'];
 else $topmenu = false;

 if ($topmenu) $menu_id = wp_get_nav_menu_object($topmenu);
 else return true; // nothing there to delete

 $foundid = false;
 $menu_items = wp_get_nav_menu_items($menu_id);
 foreach ($menu_items as $menu_item)
 {
  if ($menu_item->menu_item_parent == 0)
  {
   if ($menu_item->url == wsnkb_dirurl().'/') $foundid = $menu_item->ID;
  }
 }

 if ($foundid) wp_delete_post($foundid); //else there's nothing to delete and we can just return
 return true;
}

function wsnkb_addlinktomenu($items, $args)
{
// we could use this to add submenus that respect wsn switches, based on cache wsn can write for guests and members?
 global $wsninstalltitle;
 wsnkb_setvars();
    //if( $args->theme_location == 'primary' )
    //echo "!!!!{$args->menu}!!!!";

    //if (!strstr($items, wsnkb_dirurl()) && wsnkb_pluginisactive()) $items .= "<li><a href='".wsnkb_dirurl()."/'>{$wsninstalltitle}</a></li>";


 $pat = preg_quote('<li ').'(.*?)'.preg_quote('><a href="'.wsnkb_dirurl().'/">').'(.*?)'.preg_quote('</a></li>');
 $pat = str_replace('/', '\/', $pat);
 $test = preg_match("/$pat/i", $items, $match); // so we can handle altered titles
 if ($test)
 {

  $wsnline = $match[0];
  if (is_user_logged_in()) $usergroup = 2; else $usergroup = 1;
  $cachepath = wsnkb_installedpath()."cache/wpsubmenu{$usergroup}.cache";
  if (file_exists($cachepath)) $submenu = file_get_contents($cachepath);
  else $submenu = wsnkb_geturl(wsnkb_dirurl()."/ajax.php?action=wpsubmenu&usergroup=$usergroup", 2);
  $withmenu = str_replace('</li>', $submenu.'</li>', $wsnline);
  $withmenu = str_replace('<li>', '
  <li id="" class="menu-item menu-item-type-custom menu-item-object-custom">', $withmenu);
  $items = str_replace($wsnline, $withmenu, $items);

 }

   $items = str_replace('wsn menu-item', 'wsn menu-item menu-item-has-children', $items);
  $items = str_replace('<ul>', '<button class="submenu-expand" tabindex="-1"><svg class="svg-icon" width="24" height="24" aria-hidden="true" role="img" focusable="false" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M7.41 8.59L12 13.17l4.59-4.58L18 10l-6 6-6-6 1.41-1.41z"></path><path fill="none" d="M0 0h24v24H0V0z"></path></svg></button><ul class="sub-menu">', $items);

  // we should be able to use wp 5 version without any adverse effects on wp 4 i think

 /* WP 4:

 <li id="menu-item-6" class="wsn menu-item menu-item-type-custom menu-item-object-custom menu-item-6"><a href="http://pgk-desktop/testing/wordpress/links/">Links</a><ul><li><a href="http://pgk-desktop/testing/wordpress/links/memberlist.php">Members</a></li><li><a href="http://pgk-desktop/testing/wordpress/links/calendar.php">Calendar</a></li><li><a href="http://pgk-desktop/testing/wordpress/links/newposts.php">Latest</a></li><li><a href="http://pgk-desktop/testing/wordpress/links/chat.php">Chat</a></li><li><a href="http://pgk-desktop/testing/wordpress/links/help.php">Help</a></li><li><a href="http://pgk-desktop/testing/wordpress/links/register.php">Register</a></li><li><a href="http://pgk-desktop/testing/wordpress/links/index.php?action=userlogin">Log In</a></li></ul></li>

 WP 5:
 <li id="menu-item-10" class="menu-item menu-item-type-custom menu-item-object-custom menu-item-has-children menu-item-10"><a href="http://testparent.com" aria-haspopup="true" aria-expanded="false">test parent</a><button class="submenu-expand" tabindex="-1"><svg class="svg-icon" width="24" height="24" aria-hidden="true" role="img" focusable="false" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M7.41 8.59L12 13.17l4.59-4.58L18 10l-6 6-6-6 1.41-1.41z"></path><path fill="none" d="M0 0h24v24H0V0z"></path></svg></button>
<ul class="sub-menu">
	<li id="menu-item--1" class="mobile-parent-nav-menu-item menu-item--1"><button class="menu-item-link-return" tabindex="-1"><svg class="svg-icon" width="24" height="24" aria-hidden="true" role="img" focusable="false" viewBox="0 0 24 24" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"><path d="M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12z"></path><path d="M0 0h24v24H0z" fill="none"></path></svg>test parent</button></li>
	<li id="menu-item-7" class="menu-item menu-item-type-custom menu-item-object-custom menu-item-7"><a href="http://test.com">test 1</a></li>
	<li id="menu-item-8" class="menu-item menu-item-type-custom menu-item-object-custom menu-item-8"><a href="http://test2.com">test 2</a></li>
	<li id="menu-item-9" class="menu-item menu-item-type-custom menu-item-object-custom menu-item-9"><a href="http://test3.com">test 3</a></li>
</ul>
</li>*/

    return $items;
}

function wsnkb_fixbadprefix()
{ // fix the 1.20 bad saved prefix bug
// disabled now because it caused error
 global $alltables;
 wsnkb_setvars();
 $currentprefix = wsnkb_getdbdata('wsninstalledprefix');
 reset($alltables);
 $good = false;
 foreach($alltables as $table)
 {
  if (strstr($table, $currentprefix)) $good = true; // error: empty needle!
 }
 if (!$good)
 {
  $goodprefix = wsnkb_getlastdbprefix();
  wsnkb_setdbdata('wsninstalledprefix', $goodprefix);
 }
}

function wsnkb_getlastdbprefix()
{ // get the last used prefix... for the sake of fixing a wrongly saved prefix value when they update from 1.20 to 1.21
 global $wpdb, $scriptname, $alltables;
 wsnkb_setvars();
 if (!$scriptname) die("missing scriptname");
 reset($alltables);
 $try = $scriptname.'_';
 foreach ($alltables as $t) { if (strstr($t, $try)) $lastused = $try; }
 for($x=1;$x<100;$x++)
 {
  $try = $scriptname.$x.'_';
  reset($alltables);
  foreach ($alltables as $t) { if (strstr($t, $try)) $lastused = $try; }
 }
 return $lastused; // will always have some value
 die("Error, should never reach this point in wsnkb_getdbprefix!");
}

function wsnkb_getdbprefix()
{
 global $wpdb, $scriptname, $alltables;
 wsnkb_setvars();
 if (!$scriptname) die("missing scriptname");
 $try = $scriptname.'_';
 reset($alltables);
 $used = false;
 foreach ($alltables as $t) { if (strstr($t, $try)) $used = true; }
 if (!$used) return $try;
 for($x=1;$x<100;$x++)
 {
  $try = $scriptname.$x.'_';
  reset($alltables);
  $used = false;
  foreach ($alltables as $t) { if (strstr($t, $try)) $used = true; }
  if (!$used) return $try;
 }
 die("Error, should never reach this point in wsnkb_getdbprefix!");
}

function wsnkb_setvars()
{
 global $wpdb, $scriptname, $defaultscript, $brandprefix, $thisfilename, $wsninstalltitle, $wsnscripttitle, $alltables;
 $brandprefix = 'WSN';
 $defaultscript = 'wsnkb';
 $scriptname = $defaultscript;
 if (!$thisfilename) $thisfilename = wsnkb_uploadparent().'wp-content/plugins/'.$defaultscript.'forwordpress.php';
 $wsninstalltitle = ucwords(str_replace('wsn', '', $scriptname));
 if ($wsninstalltitle == 'Kb') $wsninstalltitle = 'Articles';
 if ($wsninstalltitle == 'Sd') $wsninstalltitle = 'Software';
 $wsnscripttitle = ucwords(str_replace('wsn', 'WSN ', $scriptname));
 if ($wsnscripttitle == 'Kb') $wsnscripttitle = 'Knowledge Base';
 if ($wsnscripttitle == 'Sd') $wsnscripttitle = 'Software Directory';

 if (!isset($alltables) || !is_array($alltables))
 {
  $result = $wpdb->get_results("SHOW TABLES", ARRAY_N);
  $n = count($result);
  for($x=0;$x<$n;$x++) { $alltables[] = $result[$x][0]; }
 }

}

function wsnkb_installit()
{

 global $scriptname, $wpdb, $defaultscript, $brandprefix;
 wsnkb_setvars();
 $lang = wsnkb_setlang();
$setuptype = 'free';

add_action('admin_menu', 'wsnkb_addadminmenupage');

$trimvars = explode(' ', 'hostname username password database thedbserver thedbuser thedbpassword thedbname');
foreach($trimvars as $t)
{
 if (isset($_REQUEST[$t]))
 {
  $_REQUEST[$t] = trim($_REQUEST[$t]);
  $_POST[$t] = trim($_REQUEST[$t]);
  $_GET[$t] = trim($_REQUEST[$t]);
 }
}



$trialdownloadurl = "http://scripts.webmastersite.net/downloads.php?type=$setuptype&format=targz&scriptname={SCRIPTNAME}&source=autosetup";

if (ini_get('magic_quotes_runtime')) die($lang['quotesruntime']);




$scriptname = $defaultscript;

$scriptsitepathbit = $scriptname;

if (isset($_REQUEST['debug'])) $debug = $_REQUEST['debug']; else $debug = false;
$trialdownloadurl = str_replace("{SCRIPTNAME}", $scriptsitepathbit, $trialdownloadurl);
$trial = true;

 $_POST['thedbname'] = DB_NAME;
 $_POST['thedbuser'] = DB_USER;
 $_POST['thedbpassword'] = DB_PASSWORD;
 $_POST['thedbserver'] = DB_HOST;
 $_POST['accountemail'] = get_option('admin_email');
 $_POST['prefix'] = wsnkb_getdbprefix();
 $_POST['dirurl'] = wsnkb_dirurl();
 $_POST['languages'] = array('English', 'Spanish', 'French', 'German', 'Russian', 'Dutch', 'Portuguese'); // actually handled in setup.php now
 $_POST['defaultlang'] = 'English';
 $_POST['scriptname'] = 'wsnkb';
 $_POST['username'] = 'admin';
 $_POST['userpassword'] = str_replace(array('0', '1', '2', '3', '4', '5', '6', 'f', 'e'), array('z', 'Y', '!', 'i', 'v', 'M', '*', 'F', 'E'), substr(md5(microtime()), 0, 8));
 $_POST['admindir'] = 'wsnadmin';

 $merged = array_merge($_GET, $_POST);
 foreach($merged as $key => $value) { if (!is_array($value)) { $$key = urldecode($value); } }

 $installtocurrentdir = false;
 $dirurl = trim(str_replace(' ', '-', $dirurl), '/ '); // remove trailing slash and spaces, transform middle spaces
 $theuploadpath = wsnkb_uploadpath();
 $theuploadpath = rtrim($theuploadpath, '/').'/';
 wsnkb_fakerequest('uploadpath', $theuploadpath);
 wsnkb_fakerequest('dirurl', wsnkb_dirurl());

 $uploadbits = explode('/', rtrim($theuploadpath, '/'));
 $parentdir = str_replace(end($uploadbits).'/', '', $theuploadpath);

 if (!strstr(php_sapi_name(), 'cgi') && !is_writeable($parentdir))
 {
   if (stristr(PHP_OS, 'win')) die($lang['windowspermissions']); else die($lang['pleasechmod']);
 }

mkdir($theuploadpath);

// download and extract, then
// simply pass all the $_POST values into a post to setup.php
$d = $trialdownloadurl.'&dirurl='.urlencode($dirurl).'&adminemail='.urlencode($accountemail);
$d .= '&actiontype=installation';
//$d .= '&testing=1';
$currenttargz = wsnkb_uploadparent().'current.tar.gz';
$bundledarchive = wsnkb_bundledarchive();
if ($bundledarchive)
{
 $f = $bundledarchive;
}
else
{
 $f = wsnkb_geturl($d);
}

if (!$f) die($lang['bug']); // fopen/curl ARE working or we wouldn't have gotten this far, so WSN must be broken
$fsize = strlen($f);
wsnkb_filewrite($currenttargz, $f);
// verified that the file written from $bundledarchive is good. so where's the problem?
$currentsize = filesize($currenttargz);
if ($currentsize < 25000) { $info = file_get_contents("current.tar.gz"); unlink($currenttargz); if (strstr($info, 'installation URLs')) die($info); } // probably a message we need to echo about having used too many licenses
if ($currentsize < 2999999) { unlink($currenttargz); die($lang['baddownload']." (current.tar.gz was only $currentsize bytes from source of $fsize bytes)"); }
//echo ":$fsize vs $currentsize:";
//die("trying to extract $currenttargz inside ".wsnkb_uploadparent()." to create ".wsnkb_uploadpath());
if (file_exists(wsnkb_uploadparent().$scriptname)) rename(wsnkb_uploadparent().$scriptname, wsnkb_uploadparent().'tempwsnalt'); // if there's already a ...wordpress/wsnkb we need to temporarily rename it to extract
wsnkb_tartodirectory($currenttargz, wsnkb_uploadparent(), wsnkb_uploadparent().$scriptname);
rename(wsnkb_uploadparent().$scriptname, wsnkb_uploadpath());
if (file_exists(wsnkb_uploadparent().'tempwsnalt')) rename(wsnkb_uploadparent().'tempwsnalt', wsnkb_uploadparent().$scriptname);
if (!file_exists(wsnkb_uploadpath().'index.php')) die("Failed to extract $currenttargz!");
unset($tar_object);
$tmp = explode('/', $dirurl);
$dir = end($tmp);

$qs = '';
$skip = ' action filled plugin dirurl uploadpath _wpnonce ';
$merged = array_merge($_GET, $_POST);
foreach($merged as $key => $value)
{
 if (!strstr($skip, " $key "))
 {
  if (is_array($value))
  {
   foreach($value as $k => $v) $qs .= '&'.$key.'['.$k.']='.urlencode($v);
  }
  else $qs .= '&'.$key.'='.urlencode($value);
 }
}
if (isset($_REQUEST['nolocalurls'])) $nolocalurls = 1; else $nolocalurls = '';
$qs = '?agree=yes&filled=1&action=create&fromautosetup=1&nolocalurls='.$nolocalurls. $qs;
$qs .= '&wordpressprefix='.$wpdb->prefix;
$qs .= '&fast=1'; // skips .htaccess write to make it faster, as of 10.2.19 Beta 2
$setupurl = wsnkb_dirurl().'/setup.php'.$qs;

if (!$nolocalurls) $out = wsnkb_geturl($setupurl); else $out = false;
if (!$out)
{ // on some strange servers, the files all download and copy fine but the setup.php call returns blank
  // for them, give a manual click option
 die('Unable to auto-install due to lack of local url access or slow server response... <a href="'.$setupurl.'">click here to complete setup</a></body></html>');
}

//http://pgk-desktop/testing/wordpress/wsnkb/setup.php?agree=yes&filled=1&action=create&fromautosetup=1&nolocalurls=&action=error_scrape&plugin=wsnkbforwordpress.php&_wpnonce=de583c3d77&uploadpath=%2Fvar%2Fwww%2Fhtml%2Ftesting%2Fwordpress%2Fwsnkb%2F&dirurl=http%3A%2F%2Fpgk-desktop%2Ftesting%2Fwordpress%2Fwsnkb&
$basepath = wsnkb_uploadpath();

if (!file_exists($basepath.'config.php'))
{
die($out);
 $failed = $lang['installfailed'];
 $failed = str_replace('{INSTALLFORM}', 'http://scripts.webmastersite.net/'.$scriptsitepathbit.'/?section=trial', $failed);
 $failed = str_replace('{SUPPORTURL}', 'http://scripts.webmastersite.net/'.$scriptsitepathbit.'/?section=support', $failed);
 $failed = str_replace('{HOSTEDURL}', 'http://scripts.webmastersite.net/'.$scriptsitepathbit.'/?section=hosted', $failed);
 wsnkb_removeinstall($basepath); // we can't delete the whole directory, because they may install to base directory they have other scripts under
 die($failed);
}
else
{ // success!
 unlink(wsnkb_uploadparent()."current.tar.gz"); // clean up
 // no output on success
}

}

function wsnkb_servercheck()
{
$lang = wsnkb_setlang();

// BEGIN SERVER TEST AREA

 ob_start();
 eval("echo 'OK';");
 $bufferoutput = ob_get_contents();
 ob_end_clean();

$partial = ''; $failed = ''; $server = '';

if (!wsnkb_writetest()) { $server .= $lang['chmodmarkertext']; $failed .= '|||chmod|||'; }

if ($bufferoutput != 'OK') { $server .= "{$lang['bufftext']} - {$lang['failtext']} <br />"; $failed .= '|||buffering|||';  }

if (!version_compare(phpversion(), "7.4.0", ">=")) { $server .= "{$lang['phptext']} ". phpversion() ." - {$lang['failtext']} <br />"; $fail .= '|||PHP|||'; }

$exts = '';
foreach (get_loaded_extensions() as $extension) $exts .= " $extension ";
$suphp = false;

if (stristr(php_sapi_name(), 'cgi')) $suphp = true;
if (!stristr(php_sapi_name(), 'cgi') && !stristr(php_sapi_name(), 'apache'))
{ // probably litespeed or something so we have to perform a test
 if (wsnkb_writetest()) $suphp = true;
}
else
{

}

$allowedmemory = ini_get("memory_limit");
if ((wsnkb_allowed_bytes('memory_limit') < 8000000 && version_compare(phpversion(), "5.4.0", ">=")) || (wsnkb_allowed_bytes('memory_limit') < 32000000 && version_compare(phpversion(), "5.4.0", "<"))) { $failed .= '|||memory|||'; $server .= "{$lang['allowedmemory']} ($allowedmemory) - {$lang['failtext']}<br />"; }

$maxpost = wsnkb_allowed_bytes('post_max_size');
if (wsnkb_allowed_bytes('post_max_size') < 9000000) { $partial .= '|||post|||'; $server .= "{$lang['maxpost']} ($maxpost) - {$lang['partialtext']}<br />"; }
//else $server .= "{$lang['maxpost']} ($maxpost) - {$lang['passtext']}<br />";

$maxupload = wsnkb_allowed_bytes('upload_max_filesize');
if (wsnkb_allowed_bytes('upload_max_filesize') < 9000000) { $partial .= '|||upload|||'; $server .= "{$lang['maxupload']} ($maxupload) - {$lang['partialtext']}<br />"; }
//else $server .= "{$lang['maxupload']} ($maxupload) - {$lang['passtext']}<br />";

if (!function_exists('mb_internal_encoding')) { $partial .= '|||mbstring|||'; $server .= "{$lang['mbtext']} - {$lang['partialtext']}<br />"; }
//else $server .= "{$lang['mbtext']} - {$lang['passtext']}<br />";

if ($failed == '') $alltrue = true; else $alltrue = false;

if (!$alltrue)
{
 $server .= $lang['toobadtext'];
 if (strstr($failed, '|||GD|||') || strstr($partial, '|||GD|||'))
 $server .= "<br> {$lang['gdexplain']} ";
 if (strstr($failed, '|||buffer|||'))
 $server .= "<br> {$lang['bufferexplain']} ";
  if (strstr($failed, '|||memory|||'))
 $server .= "<br> {$lang['memoryexplain']} ";
}

 return $server;
}

function wsnkb_hasindex($path)
{
 $has = false;
 $f = wsnkb_getfiles($path);
 if (is_array($f))
 {
  foreach ($f as $o)
  {
   if (strstr($o, 'index')) $has = true;
  }
 }
 return $has;
}

function wsnkb_prefixused()
{ // see if the tables prefix is already in use
 global $lang, $alltables;
 wsnkb_setvars();
 $ret = false;
 reset($alltables);
 foreach($alltables as $table)
 {
  if (preg_match('/'.preg_quote($_POST['prefix']).'(.*?)/', $table)) $ret = true;
 }
 return $ret;
}

function wsnkb_removeinstall($installdir)
{ // we can't delete the whole directory, because they may install to base directory they have other scripts under
 $installdir = rtrim($installdir, '/');
 $base = explode(',', file_get_contents("$installdir/schemas/basefiles.wsn"));
 foreach ($base as $b)
 {
  $b = ltrim($b, '/');
  if (!strstr($b, '.') && file_exists("$installdir/$b")) wsnkb_removedirectory("$installdir/$b"); // must be a directory
  else if (file_exists("$installdir/$b")) unlink("$installdir/$b");
 }
 if (file_exists("$installdir/config.php.txt")) unlink("$installdir/config.php.txt");
 return true;
}

function wsnkb_installdirname()
{
 $installpath = wsnkb_uploadpath();
 $installpath = rtrim($installpath, '/');
 $parts = explode('/', $installpath);
 $n = count($parts);
 $last = $n-1;
 return $parts[$last];
}

function wsnkb_dirurl()
{
 global $scriptname;
 if (wsnkb_installedpath())
 {
  return get_site_url().'/'.wsnkb_installdirname();
 }
 else
 {
 $dirurl = wsnkb_currenturl();
 $pts = explode('/', $dirurl);
 $dirurl = str_replace('/'.end($pts), '', $dirurl);
 if (strstr($dirurl, '?')) { $pts = explode('?', $dirurl); $dirurl = $pts[0]; }

 $dirurl = str_replace('/wp-admin', '', $dirurl);
 $dirurl .= "/".wsnkb_installdirname();

 return rtrim($dirurl,'/');
 }
}

function wsnkb_uploadparent()
{ // this will return the wordpress base directory
 $path = wsnkb_uploadpath();
 $last = wsnkb_installdirname();
 $path = str_replace("/$last/---", "/", "$path---");
 return $path;
}

function wsnkb_uploadpath()
{
  global $scriptname, $theuploadpath;
  if (!$scriptname) wsnkb_setvars();
  if ($theuploadpath) return $theuploadpath; // important to use cached version or later in install it goes bad
  if (wsnkb_installedpath()) return wsnkb_installedpath();
  $realpath = wsnkb_currentpath();
  $realpath = str_replace('/wp-admin/', '/', $realpath);
  $use = str_replace('wsn', '', $scriptname);
  if (file_exists($realpath.$use))
  {
   for($x=1;$x<25;$x++)
   {
    if (!file_exists($realpath.$use.$x)) break;
   }
   $realpath .= $use.$x;
  }
  else $realpath .= $use;
  $realpath = rtrim($realpath, '/').'/';
  $theuploadpath = $realpath;
  return $theuploadpath;
}


function wsnkb_currentpath()
{
  $realpath = '';
  $path = $_SERVER["SCRIPT_FILENAME"];
  if (!$path) $path = $_SERVER["ORIG_SCRIPT_FILENAME"];
  if (!$path) die("Could not calculate file path! Must be a previously unknown server configuration. Please report this.");
  $path = str_replace('\\', '/', $path);
  $path = explode('/', $path);
  for ($x=0; $x < (sizeof($path)-1) ; $x++)
  {
   $realpath .= $path[$x] .'/';
  }
  return $realpath;
}

function wsnkb_getfiles($path, $extension = '')
{ // collect all files from directory
 global $debug;
 $sets = false;
  if($handle = @opendir($path))
  {
   // Loop through all files
   while(false !== ($file = readdir($handle)))
   {
    // Ignore hidden files
    if(!preg_match("/^\./", $file))
    {
     // Put files in $files[]
     $full = $path.'/'.$file;
     if (!is_dir($full) && $file != '')
     {
	$sets[] = $file;
     }
    }
   }
  }
  @closedir($handle);
 return $sets;
}

function wsnkb_currenturl()
{
  if (strstr($_SERVER['SERVER_PROTOCOL'], 'HTTPS')) $protocol = 'https://';
  else $protocol = 'http://';
  $url = $protocol . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'];
  if ($_SERVER['QUERY_STRING'] && !strstr($url, $_SERVER['QUERY_STRING'])) $url .= '?'. $_SERVER['QUERY_STRING'];
  return $url;
}

function wsnkb_filewrite($filename, $data)
{
 global $debug, $langextras, $lang;
 $check = file_put_contents($filename, $data);
 if (!$check && !is_writeable($filename)) { die($lang['pleasechmod']); }
  if (!stristr(php_sapi_name(), 'cgi')) chmod($filename, 0666); else chmod($filename, 0644); // needed for evil liquidweb bug
 return $check;
}

function wsnkb_geturl($url, $seconds = 60)
{
 $url = str_replace('&amp;', '&', $url); // would fail on &amp;
 if (ini_get('allow_url_fopen') == '1')
 {
  $ctx = stream_context_create(array('http' => array('timeout' => $seconds)));
  $filecontents = file_get_contents($url, false, $ctx);
 }
 else if (extension_loaded('curl'))
 { // curl seems to randomly timeout more
   $user_agent = 'Mozilla/4.0 (compatible; WSN Scripts +http://www.webmastersite.net)';
   $ch = curl_init();
   curl_setopt ($ch, CURLOPT_URL, $url);
   curl_setopt ($ch, CURLOPT_USERAGENT, $user_agent);
   curl_setopt ($ch, CURLOPT_HEADER, false);
   curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
   curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $seconds);  // timeout after 15 seconds
   curl_setopt ($ch, CURLOPT_TIMEOUT, $seconds);  // timeout after 15 seconds
   @curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, true); // sometimes generates error in safe mode
   $filecontents = curl_exec ($ch);
   curl_close ($ch);
// curl_error($ch); // for debugging
 }
 else return false;
 return $filecontents;
}

// File functions

function wsnkb_removedirectory($directory, $empty = false, $leaveitself = false)
{ // recursively empties and removes specified directory
 // if the path has a slash at the end we remove it here
 if(substr($directory,-1) == '/') $directory = substr($directory,0,-1);
 // if the path is not valid or is not a directory ...
 if (!file_exists($directory) || !is_dir($directory)) return false;
 else if (!is_readable($directory)) return false;
 else
 {
  $handle = opendir($directory);
  while (FALSE !== ($item = readdir($handle)))
  {
	if($item != '.' && $item != '..')
	{
		$path = $directory.'/'.$item;
		if(is_dir($path)) wsnkb_removedirectory($path);
		else
		{
		 @unlink($path);
		 if (file_exists($path)) { unlink($path); }
		}
	}
  }
  closedir($handle);
  if ($empty == false && !$leaveitself) { rmdir($directory); }
  return true;
 }
}


function wsnkb_recursivecopy($source, $dest, $directory = false)
{ // recursively copies specified directory.
// bug: need to copy empty directories too!
 if (!$directory) $directory = $source;
 // if the path has a slash at the end we remove it here
 if(substr($directory,-1) == '/') $directory = substr($directory,0,-1);
 // if the path is not valid or is not a directory ...
 if (!is_dir($directory)) die("Fatal error: $directory is not a directory.");
 else if (!is_readable($directory)) die ("Fatal error: $directory is not readable.");
 else
 {
  $handle = opendir($directory);
  while (FALSE !== ($item = readdir($handle)))
  {
   if($item != '.' && $item != '..')
   {
    $path = $directory.'/'.$item;
    $newdirectory = str_replace(rtrim($source, '/'), rtrim($dest, '/'), $directory);
    if (!file_exists($newdirectory)) wsnkb_makethedirectory($newdirectory);
    $newpath = $newdirectory.'/'.$item;
    if(is_dir($path)) wsnkb_recursivecopy($source, $dest, $path);
    else { copy($path, $newpath); @chmod($newpath, 0644); }
   }
  }
  $newdirectory = str_replace(rtrim($source, '/'), rtrim($dest, '/'), $directory);
  if (!file_exists($newdirectory)) wsnkb_makethedirectory($newdirectory); // include empty directories
  closedir($handle);
 }
 return true;
}

 function wsnkb_allowed_bytes($inival = 'memory_limit')
 { // convert memory limit from php.ini into bytes
  $bytes = 0;
  $bytes = wsnkb_return_bytes(ini_get($inival));
  return $bytes;
 }


function wsnkb_return_bytes($val) {
// converts 8M etc from ini_get to byte value
    $val = trim($val);
    $last = strtolower($val[strlen($val)-1]);
    $val = str_ireplace($last, '', $val);
    switch($last) {
        // The 'G' modifier is available since PHP 5.1.0
        case 'g':
            $val *= 1024;
        case 'm':
            $val *= 1024;
        case 'k':
            $val *= 1024;
    }

    return $val;
}

function wsnkb_fakerequest($var, $val)
{
 global $$var;
 $$var = $val;
 $_REQUEST[$var] = $val;
 $_GET[$var] = $val;
 $_POST[$var] = $val;
 return true;
}

function wsnkb_getservertype()
{
 $server = $_SERVER['SERVER_SOFTWARE'];
 if (stristr($server, 'litespeed')) return 'litespeed';
 else if (strstr($server, ' IIS')) return 'iis';
 else if (stristr($server, 'apache')) return 'apache';
 else return "unknown server type: $server";
}

function wsnkb_makethedirectory($dir)
{ // simplified 5/21/17: as long as the parent directory is 777, we should be fine to mkdir 0755 even in apache mode right? using 0777 was killing site on litespeed, might on apache too.
 global $ftpc;
 $dir = rtrim($dir, '/'); // suggestion of php manual comment
 //$dir = str_replace('./', '', $dir);
 $test = mkdir($dir, 0755);
 chmod($dir, 0755); // needed for evil liquidweb bug
 return $test;
}

function wsnkb_writetest()
{
  $ret = false;
  wsnkb_filewrite("1.txt", "test");
  if (file_exists("1.txt")) { $ret = true; unlink("1.txt"); }
  return $ret;
}

function wsnkb_shutdown()
{
 global $bugreportcount, $autosetupversion;
 $error = error_get_last();
 if (isset($error) && is_array($error) && ($error['type'] === E_ERROR || $error['type'] === E_CORE_ERROR || $error['type'] === E_COMPILE_ERROR || $error['type'] === E_USER_ERROR || $error['type'] === E_RECOVERABLE_ERROR || $error['type'] === E_CORE_WARNING || $error['type'] === E_COMPILE_WARNING || $error['type'] === E_PARSE))
 { // fatal error has occured. let's try to send a bug report.

  $reportit = true;
  $emsg .= "Fatal error {$error['message']} occurred on line {$error['line']} of file {$error['file']} on ".date('Y-m-d H:i:s').".";
  if (isset($_SERVER['HTTP_REFERER'])) $ref = $_SERVER['HTTP_REFERER']; else $ref = 'undefined';
  $emsg .= "

The referring URL was $ref.";
  if ($reportit && $bugreportcount < 3)
  {
   $bugreportcount++;
   $message = "Script: wsnkbforwordpress.php
Category: Automatic Bug Reports
Version: $autosetupversion
PHP Version: ".phpversion()."

$emsg";
   $subject = "Autosetup Automatic Bug Report";
   $to = wsnkb_asciitotext('97 | 117 | 116 | 111 | 98 | 117 | 103 | 114 | 101 | 112 | 111 | 114 | 116 | 115 | 64 | 119 | 101 | 98 | 109 | 97 | 115 | 116 | 101 | 114 | 115 | 105 | 116 | 101 | 46 | 110 | 101 | 116 |'); // some obfuscation to thwart spam spiders
   if ($_REQUEST['accountemail']) $from = $_REQUEST['accountemail'];
   else $from = 'anonymous@'.$_SERVER['HTTP_HOST'];
   mail($to, $subject, $message, "From: $from");
  }
 }
}


function wsnkb_errorhandler($errno, $errstr, $errfile, $errline)
{ // process errors which PHP allows us to process
 global $debug, $bugreportcount, $autosetupversion;
 if (error_reporting() == 0) return; // this indicates that @ error supression was used, so don't do anything
 $backtrace = wsnkb_backtracetostring(debug_backtrace());
 if (strstr($backtrace, 'errorhandler')) return true; // it seems the error occured in errorhandler function itself and we don't want to be infinitely recursive!
 $reportit = true;
 $autoreported = false;
 $emsg = '';
 switch ($errno)
 {
  case E_WARNING:
  case E_CORE_WARNING:
  case E_COMPILE_WARNING:
  $emsg = "Warning #$errno: '$errstr' in $errfile on line $errline.";
  case E_RECOVERABLE_ERROR:
  $emsg = "Recoverable error #$errno: '$errstr' in $errfile on line $errline";
  case E_ERROR:
  case E_USER_ERROR:
  $emsg = "Error #$errno: '$errstr' in $errfile on line $errline.";
  break;
  case E_USER_WARNING:
  $emsg = "Warning #$errno: '$errstr' in $errfile on line $errline";
  break;
  case E_NOTICE:
  case E_USER_NOTICE:
  //if (strstr($errstr, "to get property of")) $emsg = "Error #$errno: '$errstr' in $errfile on line $errline"; // property of non-object notices are useful, right?
  if ($debug == 8)
  {
   $emsg = "\nYou've selected to display NOTICES, which is for developer information only -- on a real site, set your debug level to normal at Admin Panel -> Settings -> System Settings.\n\nE_NOTICE #$errno: '$errstr' in $errfile on line $errline\n";
   $shorterr = true;
   $reportit = false;
  }
  break;
  case E_STRICT:
  case E_DEPRECATED:
  if ($debug == 7 || $debug == 8 || wsnkb_currenturlcontains('pgk-desktop'))
  {
   $emsg = "\nYou've selected to run in STRICT MODE, which is for developer information only -- on a real site, set your debug level to normal at Admin Panel -> Settings -> System Settings.\n\nE_STRICT #$errno: '$errstr' in $errfile on line $errline";
   $shorterr = true;
   $reportit = false;
  }
  break;
  default:
  $emsg = "Unhandled error #$errno: '$errstr' in $errfile on line $errline";
  break;
 }

 if (!$emsg || strstr($emsg, 'Access denied for user') || strstr($emsg, 'connect to ')) return true; // if no message set, that means we want to suppress it

 $emsg .= "Error occurred on ".date('Y-m-d H:i:s').".";
 $emsg .= $backtrace;
 if ($emsg && $bugreportcount < 3)
 {
  $bugreportcount++;

  if (isset($_SERVER['HTTP_REFERER'])) $ref = $_SERVER['HTTP_REFERER']; else $ref = 'undefined';
  $emsg .= "

The referring URL was $ref.";

$message = "Script: wsnkbforwordpress.php
Category: Automatic Bug Reports
Version: $autosetupversion
PHP Version: ".phpversion()."

$emsg";

   $subject = "Autosetup Automatic Bug Report";
   $to = wsnkb_asciitotext('97 | 117 | 116 | 111 | 98 | 117 | 103 | 114 | 101 | 112 | 111 | 114 | 116 | 115 | 64 | 119 | 101 | 98 | 109 | 97 | 115 | 116 | 101 | 114 | 115 | 105 | 116 | 101 | 46 | 110 | 101 | 116 |'); // some obfuscation to thwart spam spiders
   if (isset($_REQUEST['accountemail']) && $_REQUEST['accountemail']) $from = $_REQUEST['accountemail'];
   else $from = 'anonymous@'.$_SERVER['HTTP_HOST'];
   mail($to, $subject, $message, "From: $from");


 }
 return true; // true = let's try to continue
}


function wsnkb_backtracetostring($backtrace)
{ // reformat debug_backtrace() as string for echo instead of an array
 $string = '';
 $n = count($backtrace);
 for ($x=1; $x<$n; $x++)
 { // skip first one since it's always the error handler function itself
  $string .= "\nStep $x of backtrace: \n";
  if (isset($backtrace[$x]['file'])) $string .= "File: ".$backtrace[$x]['file']."\n";
  if (isset($backtrace[$x]['line'])) $string .= "Line: ".$backtrace[$x]['line']."\n";
  if (isset($backtrace[$x]['function'])) $string .= "Function: ".$backtrace[$x]['function']."\n";
  if (isset($backtrace[$x]['args']))
  {
   $string .= "Arguments: ";
   foreach ($backtrace[$x]['args'] as $arg) { if (is_string($arg) && strlen($arg) < 100) $string .= "$arg "; else if (is_array($arg)) $string .= "array "; else if (is_object($arg)) $string .= "object "; }
   $string .= "\n";
  }
  if (isset($backtrace[$x]['class'])) $string .= "Class: ".$backtrace[$x]['class']."\n";
  //if (isset($backtrace[$x]['object'])) $string .= "Object: ".$backtrace[$x]['object']."\n";
  $string .= "\n";
 }
 return $string;
}


function wsnkb_asciitotext($ascii)
{
 $chars = explode(' | ', $ascii);
 $text = '';
 for ($x=0; $x<count($chars); $x++)
 {
  $number = intval(trim($chars[$x]));
  $text .= chr($number);
 }
 return $text;
}

function wsnkb_currenturlcontains($checkfor)
{
 global $currenturl;
 if (!$currenturl) $currenturl = wsnkb_currenturl();
 $effectiveurl = str_replace('?rewritten=1', '', str_replace('?rewritten=1&', '?', $currenturl)); // so url is the same rewritting or not
 if (!is_array($checkfor)) $checkfor = array($checkfor);
 foreach($checkfor as $cf)
 { // if ANY of the $checkfor array are in the url, we'll return true
  if (strstr($effectiveurl, $cf) === false) $exists = 0;
  else return 1;
 }
 return $exists;
}

function wsnkb_templateextract(&$template, $stringbegin, $stringend, $includebegin = true)
{
 // Must leave beginning string in so that we don't end up replacing two areas that have the rest of the same HTML!
 $pat = preg_quote($stringbegin).'(.*?)'.preg_quote($stringend);
 $pat = '/'.str_replace('/', '\/', $pat).'/ms';
 $test = preg_match($pat, $template, $match);
 if ($test)
 {
  if ($includebegin) $ret = $stringbegin.$match[1];
  else $ret = $match[1];
 }
 else $ret = false;
 return $ret;
}


function wsnkb_gzopenwrapper($name, $att)
{
 if (function_exists('gzopen')) $handler = gzopen($name, $att);
 else if (function_exists('gzopen64')) $handler = gzopen64($name, $att);
 else die("PHP's zlib extension isn't enabled! Please ask your web host to fix this.");
 return $handler;
}


function wsnkb_tarmethod()
{
 if (wsnkb_functionwillwork('shell_exec')) $ret = 'shell';
 else if (extension_loaded('phar') && extension_loaded('bz2') && extension_loaded('zlib') && class_exists('PharData')) $ret = 'phar';
 else $ret = 'legacy';
 return $ret;
}

function wsnkb_setlang()
{
// Begin translation area:
global $scriptname, $defaultscript, $brandprefix;
$lang['tarmethod'] = "Tar extraction method";
$lang['welcomeemailsubject'] = "{SCRIPTTITLE} Installation";
$lang['welcomeemailbody'] = "Congratulations, you've just installed {SCRIPTTITLE}!

Guided start: {DIRURL}/{ADMINDIR}/guided.php
Admin panel: {DIRURL}/{ADMINDIR}/
Front end: {DIRURL}/

You can learn about {SCRIPTTITLE} in the user guide: http://scripts.webmastersite.net/{SCRIPTSITEPATHBIT}/guide.html

If you have any questions or encounter any problems, please contact support by clicking the 'Support' menu option in the admin panel. {TRIALBIT}";
$lang['welcomefreeemailbody'] = "Congratulations, you've just installed {SCRIPTTITLE}!

Guided start: {DIRURL}/{ADMINDIR}/guided.php
Admin panel: {DIRURL}/{ADMINDIR}/
Front end: {DIRURL}/

You can learn about {SCRIPTTITLE} in the user guide: http://scripts.webmastersite.net/{SCRIPTSITEPATHBIT}/guide.html

If you like it, please consider purchasing to get updates and prompt support directly from the developer. Your financial support is appreciated!";
$lang['welcomeemailbodyfree'] = "

You've started a fully supported 30 day free trial. After this time elapses, your site will automatically change to the free version which will eliminate your support privledges (except for bug reports) and deactivate advanced features. If you're not looking to do anything advanced and don't want help, you can use it free forever.

If you decide to buy a license, use this link: {PURCHASELINK} . If you already own a license, go to Admin Panel -> Settings -> System Configuration and enter your license login at the top to activate.
";
$lang['windowspermissions'] = "<p>PHP needs write access to the directory which autosetup.php is in (and the directory $brandprefix is being installed to, if different). Since you're running a Microsoft Windows server that doesn't support chmod and is configured to run PHP under a different user than your FTP user, you need to contact your web host and ask them to give PHP's user write permissions to this directory.</p>";
$lang['incorrectcustomerlogin'] = "<p>The customer login you typed is incorrect. You need to type the same customer email and password which you use to login to the downloads area which you got this autosetup.php from.</p>";
$lang['pleasechmod'] = "<p style=\"font-size: 16px; color: red; font-weight: bold;\">Since your server runs PHP and FTP as different users, you must change the permissions on this directory to allow all users to read write and execute. You can right-click a folder and use the permissions menu option in cpanel's file manager, or set 777 in your FTP client. If you don't know how to do this, please <a href=\"http://scripts.webmastersite.net/$defaultscript/trial.html\">request service</a> (free) or ask your web host.</p>";
$lang['installfailed'] = "<p>Installation could not complete, some of the information you provided seems to have been invalid. Please select one of following ways to proceed:</p>
<ul>
<li>Get <a href=\"{INSTALLFORM}\">free professional installation</a>.</li>
<li>Get in touch with <a href=\"{SUPPORTURL}\">support</a>.</p>
</ul>
";
$lang['phpexplain'] = "<p>This server is running a very old version of PHP. WSN can run on this version, but memory usage is not optimized for this version and use of this version has been known to cause up to 10 times the memory use of the same page on a current version of PHP. Keep this in mind and make sure the php.ini memory_limit is high -- at least 64M is recommended for the old version of PHP you're running.</p>";
$lang['oldphp5'] = "<p>$brandprefix requires PHP 5.3 or newer (PHP 7 recommended).</p>";
$lang['oldphp'] = "<p>$brandprefix requires PHP 5.3 or newer (PHP 7 recommended).</p>";
$lang['bug'] = "There was an issue with attempting to download the software, the $brandprefix downloads area seems to not be functioning properly. Please contact support.";
$lang['passtext'] = "<font color=\"#00AA00\">optimal</font>";
$lang['partialtext'] = "<font color=\"#bbbb00\">acceptable but not optimal</font>";
$lang['failtext'] = "<font color=\"#AA0000\">fail</font>";
$lang['pagetitle'] = "Server Test";
$lang['bufftext'] = "Output buffering";
$lang['phptext'] = "PHP version";
$lang['mysqltext'] = "MySQL version";
$lang['mysqlbadlogin'] = "<p>The MySQL login username and password combo you typed were incorrect. Perhaps you've forgotten the prefix which goes before all the names you create.</p>";
$lang['mysqlbadserver'] = "<p>There's no MySQL server on the specified host. Please check the host name you typed.</p>";
$lang['oldmysql'] = "MySQL 4.1 or newer is required. You have {YOURVERSION}.";
$lang['mysqlworked'] = "<p>Access to the database was established. Everything is good.</p>";
$lang['mysqldbissue'] = "<p>The connection was established, but access to the database was denied. You've probably forgotten to grant the user access to the database in your hosting control panel.</p>";
$lang['gdtext'] = "GD";
$congratstext = "<p>This server meets all the recommendations.</p>";
$lang['toobadtext'] = "<p>Some changes need to be made before you can install $scriptname:</p>";
$lang['gdexplain'] = "If you know that you have ImageMagick available on your server, do not worry about not having GD -- you only need one or the other, not both. If you do not have ImageMagick, then you will need to install it before you can use the thumbnail and image editing features of $brandprefix Gallery. Most hosts should be willing to install ImageMagick on request if they do not already have it. If your host refuses, ImageMagick can also be installed on a shared account, it does not require root access as long as you have telnet access. Please see <a href=\"http://www.imagemagick.org\">here</a> for instructions. <br /><br />";
$lang['bufferexplain'] = "Your PHP version seems to have output buffering disabled. Contact your web host to have it enabled.";
$lang['ifyouwishtext'] = "You also need MySQL, which requires access info to test. If you'd like to test MySQL to ensure your version is recent enough, type your connection data below:";
$lang['usuallylocal'] = "(usually localhost)";
$lang['hosttext'] = "Database Host";
$lang['usertext'] = "Database Username";
$lang['passwordtext'] = "Database Password";
$lang['dbnametext'] = "Database Name";
$lang['testtext'] = "Test MySQL Info";
$lang['nonethelesstext'] = "<p>Your server meets the minimum requirements for running $scriptname. Nonetheless, there are some issues you may want to take note of:</p>";
$lang['ftpexplain'] = "Your PHP install lacks the FTP extension, and is running PHP as a different user than your FTP user. This means any files/directories which you manually upload via FTP will have to be CHMODed manually, so for reliable operation you should avoid doing any manual uploads. It'd be simpler to use a host with suPHP or equivlant run-as-user functionality.";
$lang['gdrec'] = "Your PHP install lacks the GD extension. Unless you have ImageMagick you won't be able to do thumbnails or resizing of images, but everything else will be fine.";
$lang['runtimequotes'] = "magic_quotes_runtime needs to be off, as it is by default in PHP.";
$lang['urltext'] = "Remote URL functions";
$lang['urlexplain'] = "Your web host has disabled both fopen URL wrappers and CURL. This prevents your site from accessing the rest of the internet, thus disabling many important features. Disabled features will be greyed out on your switches page. You need to ask your web host to enable at least one of fopen URL wrappers or cURL in order to enjoy all options.";
$lang['firewallexplain'] = "Your web host has a firewall rule which is preventing the loading of data from the $brandprefix server. Please contact your web host and ask them to unblock webmastersite.net and wsnforum.com so that data can be retrieved from them with cURL or fopen url wrappers. Once they've done that, return here to continue.";
$lang['apachesafeexplain'] = "Your web host is running PHP in safe_mode without suPHP. This can interfere with automatic setup or automatic upgrades, disables a few features, and generally makes your life more a pain than it needs to be. It's recommended that you ask your host to disable safe_mode on your account. Remind them that safe_mode is depreciated and  removed from PHP 7, openbasedir should be used instead.";
$lang['windowsexplain'] = "Windows IIS doesn't support URL rewriting by default. If you want the SEO advantages of rewriting you'll have to buy an IIS add-on product like ISAPI_Rewrite to enable the same functionality which Apache and Lightspeed users get free. If you're not terribly concerned about URL rewriting, forget this -- you don't have to use rewriting.";
$lang['gdmissingtext'] = "GD extension not installed";
$lang['executiontime'] = "Your host has set a maximum execution time of less than 20 seconds and disabled the ability to increase it. This might prevent automated setup/upgrades.";
$lang['maxexecutiontime'] = "Maximum Execution Time";
$lang['seconds'] = "seconds";
$lang['allowedmemory'] = "Allowed Memory";
$lang['memoryexplain'] = "$scriptname needs a memory limit of at least 8M for PHP 5.4+, and 32M for 5.3 and earlier depending on use. 64M is the recommended memory_limit value, and if you'll be using the script to process large files (big images or xml files for example) you could require a larger value. Please contact your web host to have them set memory_limit = 64M; in php.ini, or you may be able to set php_value memory_limit 64M yourself in an .htaccess file depending on your hosting configuration.";
$lang['ftpdomanual'] = "Since the install location is the same as the FTP drop point, you'll have to manually chmod the directory to 777.";
$lang['ftppathmismatch'] = "The FTP path you specified doesn't end in the same directory as the install path you specified.";
$lang['badhost'] = "MySQL is not installed at {HOST}. Please ask your web host what your MySQL host name is.";
$lang['badmysqllogin'] = "The MySQL username and password you specified are invalid. Check if you've forgotten a prefix_ value on the username, or ask your web host what your MySQL login is.";
$lang['nodbaccess'] = "The MySQL login you specified does not have access to the database you specified. Either the database name is wrong (check if you forgot a prefix_ value) or you need to assign the user access to the database in your hosting control panel. You can ask $brandprefix support or your host to do this for you.";
$lang['softcat'] = "software categories";
$lang['softlistings'] = "60,000+ software listings";
$lang['softlistingsalt'] = "18,000+ human-moderated software listings";
$lang['counties'] = "USA counties by state";
$lang['states'] = "USA states";
$lang['countries'] = "world countries";
$lang['cities'] = "USA cities by county by state";
$lang['statecounties'] = "Counties of single state";
$lang['statecities'] = "Cities by county of single state";
$lang['businesscategories'] = "business categories";
$lang['businesscategoriesbystate'] = "business categories by state/province";
$lang['chmodmarkertext'] = "<p style=\"font-size: 16px; color: red; font-weight: bold;\">Since your server runs PHP and FTP as different users, you must change the permissions on this directory to allow all users to read write and execute. You can right-click a folder and use the permissions menu option in cpanel's file manager, or set 777 in your FTP client. If you don't know how to do this, please <a href=\"http://scripts.webmastersite.net/$defaultscript/trial.html\">request service</a> (free) or ask your web host.</p>";
$lang['quotesruntime'] = "magic_quotes_runtime is enabled on this server. It must be disabled before anything can function properly.";
$lang['tryanyway'] = "Try to Install Anyway";
$lang['hostingrecs'] = "If you need new web hosting, the following hosts have been verified and can meet all requirements and recommendations:
<a href='https://www.wsnkb.com/index.php?out=dreamhost'>DreamHost</a>, <a href='https://www.wsnkb.com/index.php?out=bluehost'>Blue Host</a>, <a href='https://www.wsnkb.com/index.php?out=hostgator'>Host Gator</a>, <a href='https://www.wsnkb.com/index.php?out=liquidweb'>Liquid Web</a>, <a href='https://www.wsnkb.com/index.php?out=futurehosting'>Future Hosting</a>, <a href='https://www.wsnkb.com/index.php?out=siteground'>Site Ground</a>.";
$lang['nosuphp'] = "Your server's PHP install is configured so that PHP-created files and FTP-uploaded files have different owners and cannot be modified from the other without 777 permissions. As a result, if you ever upload anything via FTP then permissions can become a mess.";
$lang['nopermissionforseries'] = "Your customer account doesn't have permission to download the series you selected. Please <a href=\"{URL}\">purchase access</a>.";
$lang['maxpost'] = "post_max_size";
$lang['maxupload'] = "upload_max_filesize";
$lang['lowpost'] = "Your web host's php.ini file has a low limit set for post_max_size. You will not be able to upload files larger than this limit. If you plan to host videos or other large user-contributed files you'll need to increase the limit.";
$lang['lowupload'] = "Your web host's php.ini file has a low limit set for upload_max_filesize. You will not be able to upload files larger than this limit. If you plan to host videos or other large user-contributed files you'll need to increase the limit.";
$lang['localurltext'] = "Local URL functions";
$lang['localurlexplain'] = "Something -- probably a firewall rule -- prevents the server from accessing URLs on your own site.";
$lang['needsmanualupload'] = "<span style=\"font-size: 18px; color: #FF0000;\">Since this web host doesn't allow scripts to access the rest of the internet, you need to install manually, sorry. :(</span>";
$lang['totallylobotomizedhost'] = "This web host has disabled the ability to use most basic core PHP functions, such as mkdir for creating a new directory. You will need to switch to a web host that fully supports PHP. There are thousands of good hosts,  <a href='http://www.dreamhost.com/r.cgi?1459476'>Dream Host</a> is a popular one that exceeds all $brandprefix recommendations.";
$lang['baddownload'] = "There seems to be a problem with the download, please contact support.";
$lang['mbtext'] = 'mbstring extension';
$lang['mbexplain'] = "The geolocation feature requires PHP's mbstring extension, which this server lacks. You can still install $scriptname, but can't load the geolocation data -- that checkbox has been disabled.";
$lang['scriptcat'] = "web scripts categories";
// End translation area
return $lang;
}


function wsnkb_wsnkb_removedirectory($directory, $empty = false, $leaveitself = false)
{ // recursively empties and removes specified directory
 // if the path has a slash at the end we remove it here
 if(substr($directory,-1) == '/') $directory = substr($directory,0,-1);
 // if the path is not valid or is not a directory ...
 if (!file_exists($directory) || !is_dir($directory)) return false;
 else if (!is_readable($directory)) return false;
 else
 {
  $handle = opendir($directory);
  while (FALSE !== ($item = readdir($handle)))
  {
	if($item != '.' && $item != '..')
	{
		$path = $directory.'/'.$item;
		if(is_dir($path)) wsnkb_removedirectory($path);
		else
		{
		 unlink($path);
		}
	}
  }
  closedir($handle);
  if ($empty == false && !$leaveitself) { rmdir($directory); }
  return true;
 }
}

function wsnkb_tartodirectory($targz, $extractin, $expectedresult, $method = false)
{
 global $debug;
 if (!strstr($extractin, '/')) $extractin = currentpath().$extractin;
 if (wsnkb_functionwillwork('shell_exec') && $method != 'fallback' && $method != 'phar')
 { // shell extract is safest, avoids all memory/time issues, if it's available
   // tested tar zxvf /var/www/html/101/wsnkb/temp/current.tar.gz -C /var/www/html/101/wsnkb/temp/ and verified it's all good
   $cmd = "tar zxvf \"$targz\" -C \"$extractin\"";
   if ($debug) echo "<p>$cmd</p>";
   $output = shell_exec($cmd);
   //die("output from $cmd is $output");
 }
 if (!file_exists($expectedresult))
 {
  if (extension_loaded('phar') && extension_loaded('bz2') && extension_loaded('zlib') && class_exists('PharData') && $method != 'fallback')
  {
   try
   {
    $p = new PharData("$targz");
   }
   catch(Exception $e)
   {
    if (strstr($e->getMessage(), 'unable to decompress gzipped phar archive'))
    { // bad download, try again
      unlink($targz);
      echo "File seems to have been corrupted!";
      return;
    }
   }
   if (isset($p) && is_object($p))
   {
    $tar = str_replace('.tar.gz', '.tar', $targz);
    if (file_exists($tar)) unlink($tar); // if it already exists we can get confusing 500 error
    $p->decompress(); // creates /path/to/my.tar
    unset($p);
    $phar = new PharData("$tar");
    $phar->extractTo("$extractin", null, true);
    if (file_exists($tar)) unlink($tar); // no longer needed
    unset($phar);
   }
  }
  if (!file_exists($expectedresult))
  { // previous attempts failed, time for fallback
   $tar_object = new tar;
   $tar_object->open($targz);
   $tar_object->extract($extractin);
   unset($tar_object);
  }
 }
}

 function wsnkb_functionwillwork($func)
 { // a function disabled via suhosin can return true with plain function_exists, so here's a method that'll return false for a disabled function no matter how it was disabled
  $ret = true;
  $ret = function_exists($func);
  if (!wsnkb_func_enabled($func)) $ret = false;
  if (extension_loaded('suhosin'))
  {
   $suhosin = @ini_get("suhosin.executor.func.blacklist");
   if (empty($suhosin) == false)
   {
    $suhosin = explode(',', $suhosin);
    $suhosin = array_map('trim', $suhosin);
    $suhosin = array_map('strtolower', $suhosin);
    if (array_search($func, $suhosin) !== false) $ret = false;
   }
  }
  if (($func == 'set_time_limit' || $func == 'shell_exec') && ini_get('safe_mode')) $ret = false; // it won't work in safe_mode, but will still show as existing annoyingly enough
  return $ret;
 }

function wsnkb_func_enabled($func)
{
    $disabled = explode(',', ini_get('disable_functions'));
    foreach ($disabled as $disableFunction) $is_disabled[] = trim($disableFunction);
    if (in_array($func,$is_disabled)) $it_is_disabled = 0;
    else $it_is_disabled = 1;
    return $it_is_disabled;
}

function wsnkb_addmenuitem()
{
 global $wpdb, $wsninstalltitle;
 wsnkb_setvars();

 $locations = get_theme_mod('nav_menu_locations'); // Array ( [top] => 2 [menu-1] => 2 )
 //die('p00'.print_r($locations));
 if (isset($locations['top']) && $locations['top']) $topmenu = $locations['top'];
 else $topmenu = false;

 if ($topmenu)
 {
 //die('p1a'.print_r($topmenu));
  $menu_id = wp_get_nav_menu_object($topmenu);
  //echo "found top menu {$menu_id->term_id}...";
  if (!is_object($menu_id)) $topmenu = false; // referenced menu must've been deleted
 }
 if (!$topmenu)
 {
  $menuname = 'wsntopmenu';
  //echo "creating new menu named $menuname...";
  $menudbid = wp_create_nav_menu($menuname);
  $menu_id = wp_get_nav_menu_object($menudbid);
  wp_update_nav_menu_item($menudbid, 0, array(
        'menu-item-title' =>  __('Home'),
        'menu-item-classes' => 'home',
        'menu-item-url' => home_url( '/' ),
        'menu-item-status' => 'publish'));
  $locations['top'] = $menudbid;
  $locations['menu-1'] = $menudbid;
  set_theme_mod('nav_menu_locations', $locations);
  //print_r($locations);
  //echo "just set locations['top'] to {$menudbid}...";
 }

 // now we have a $menu_id for a top menu either way. search it to see if it contains a WSN link already.
 $foundid = false;
 $menu_items = wp_get_nav_menu_items($menu_id);
 if (is_array($menu_items))
 {
  foreach ($menu_items as $menu_item)
  {
   if ($menu_item->menu_item_parent == 0)
   {
    if ($menu_item->url == wsnkb_dirurl().'/') $foundid = $menu_item->ID;
   }
  }
 }

 if (!$foundid)
 { // WSN isn't in the menu yet, so add it!
//echo "adding item to menu {$menu_id->term_id}.. ";
  $itemid = wp_update_nav_menu_item($menu_id->term_id, 0, array(
        'menu-item-title' =>  $wsninstalltitle,
        'menu-item-classes' => 'wsn',
        'menu-item-url' => wsnkb_dirurl().'/',
        'menu-item-status' => 'publish'));
 }
//die("completed function");
}

function wsnkb_test()
{
 global $wpdb, $alltables;
 wsnkb_setvars();

}

function wsnkb_sendpost($posturl, $params, $optional_headers = null)
{ // $params format: postvar1=value1&postvar2=value2&postvar3=value3
 if (function_exists('curl_exec'))
 {
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL,$posturl);
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_VERBOSE, 1);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE); // turn off server and peer verification
  curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE); // turn off server and peer verification
  curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
  $ret = curl_exec($ch);
  curl_close ($ch);
 }
 else
 {
  $params = array('http' => array(
              'method' => 'POST',
              'content' => $params
            ));
  if ($optional_headers !== null) $params['http']['header'] = $optional_headers;
  $ctx = stream_context_create($params);
  $fp = @fopen($posturl, 'rb', false, $ctx);
  $ret = @stream_get_contents($fp);
 }
 return $ret;
}

function wsnkb_bundledarchive()
{
 $bundledarchive = '';
 return base64_decode($bundledarchive);
}


// now, the tar.php contents:


abstract class Archive
{

    const COMPRESS_AUTO = -1;
    const COMPRESS_NONE = 0;
    const COMPRESS_GZIP = 1;
    const COMPRESS_BZIP = 2;

    /** @var callable */
    protected $callback;

    /**
     * Set the compression level and type
     *
     * @param int $level Compression level (0 to 9)
     * @param int $type  Type of compression to use (use COMPRESS_* constants)
     * @throws ArchiveIllegalCompressionException
     */
    abstract public function setCompression($level = 9, $type = Archive::COMPRESS_AUTO);

    /**
     * Open an existing archive file for reading
     *
     * @param string $file
     * @throws ArchiveIOException
     */
    abstract public function open($file);

    /**
     * Read the contents of an archive
     *
     * This function lists the files stored in the archive, and returns an indexed array of FileInfo objects
     *
     * The archive is closed afer reading the contents, because rewinding is not possible in bzip2 streams.
     * Reopen the file with open() again if you want to do additional operations
     *
     * @return FileInfo[]
     */
    abstract public function contents();

    /**
     * Extract an existing archive
     *
     * The $strip parameter allows you to strip a certain number of path components from the filenames
     * found in the archive file, similar to the --strip-components feature of GNU tar. This is triggered when
     * an integer is passed as $strip.
     * Alternatively a fixed string prefix may be passed in $strip. If the filename matches this prefix,
     * the prefix will be stripped. It is recommended to give prefixes with a trailing slash.
     *
     * By default this will extract all files found in the archive. You can restrict the output using the $include
     * and $exclude parameter. Both expect a full regular expression (including delimiters and modifiers). If
     * $include is set, only files that match this expression will be extracted. Files that match the $exclude
     * expression will never be extracted. Both parameters can be used in combination. Expressions are matched against
     * stripped filenames as described above.
     *
     * The archive is closed afterwards. Reopen the file with open() again if you want to do additional operations
     *
     * @param string     $outdir  the target directory for extracting
     * @param int|string $strip   either the number of path components or a fixed prefix to strip
     * @param string     $exclude a regular expression of files to exclude
     * @param string     $include a regular expression of files to include
     * @throws ArchiveIOException
     * @return array
     */
    abstract public function extract($outdir, $strip = '', $exclude = '', $include = '');

    /**
     * Create a new archive file
     *
     * If $file is empty, the archive file will be created in memory
     *
     * @param string $file
     */
    abstract public function create($file = '');

    /**
     * Add a file to the current archive using an existing file in the filesystem
     *
     * @param string          $file     path to the original file
     * @param string|FileInfo $fileinfo either the name to us in archive (string) or a FileInfo oject with all meta data, empty to take from original
     * @throws ArchiveIOException
     */
    abstract public function addFile($file, $fileinfo = '');

    /**
     * Add a file to the current archive using the given $data as content
     *
     * @param string|FileInfo $fileinfo either the name to us in archive (string) or a FileInfo oject with all meta data
     * @param string          $data     binary content of the file to add
     * @throws ArchiveIOException
     */
    abstract public function addData($fileinfo, $data);

    /**
     * Close the archive, close all file handles
     *
     * After a call to this function no more data can be added to the archive, for
     * read access no reading is allowed anymore
     */
    abstract public function close();

    /**
     * Returns the created in-memory archive data
     *
     * This implicitly calls close() on the Archive
     */
    abstract public function getArchive();

    /**
     * Save the created in-memory archive data
     *
     * Note: It is more memory effective to specify the filename in the create() function and
     * let the library work on the new file directly.
     *
     * @param string $file
     */
    abstract public function save($file);

    /**
     * Set a callback function to be called whenever a file is added or extracted.
     *
     * The callback is called with a FileInfo object as parameter. You can use this to show progress
     * info during an operation.
     *
     * @param callable $callback
     */
    public function setCallback($callback)
    {
        $this->callback = $callback;
    }
}


/**
 * The archive is unreadable
 */
class ArchiveCorruptedException extends \Exception
{
}

/**
 * Bad or unsupported compression settings requested
 */
class ArchiveIllegalCompressionException extends \Exception
{
}


/**
 * Read/Write Errors
 */
class ArchiveIOException extends \Exception
{
}


/**
 * Class FileInfo
 *
 * stores meta data about a file in an Archive
 *
 * @author  Andreas Gohr <andi@splitbrain.org>
 * @package splitbrain\PHPArchive
 * @license MIT
 */
class FileInfo
{

    protected $isdir = false;
    protected $path = '';
    protected $size = 0;
    protected $csize = 0;
    protected $mtime = 0;
    protected $mode = 0664;
    protected $owner = '';
    protected $group = '';
    protected $uid = 0;
    protected $gid = 0;
    protected $comment = '';

    /**
     * initialize dynamic defaults
     *
     * @param string $path The path of the file, can also be set later through setPath()
     */
    public function __construct($path = '')
    {
        $this->mtime = time();
        $this->setPath($path);
    }

    /**
     * Handle calls to deprecated methods
     *
     * @param string $name
     * @param array $arguments
     * @return mixed
     */
    public function __call($name, $arguments)
    {
        if($name === 'match') {
            trigger_error('FileInfo::match() is deprecated, use FileInfo::matchExpression() instead.', E_USER_NOTICE);
            return call_user_func_array([$this, $name], $arguments);
        }

        trigger_error('Call to undefined method FileInfo::'.$name.'()', E_USER_ERROR);
        return null;
    }

    /**
     * Factory to build FileInfo from existing file or directory
     *
     * @param string $path path to a file on the local file system
     * @param string $as   optional path to use inside the archive
     * @throws FileInfoException
     * @return FileInfo
     */
    public static function fromPath($path, $as = '')
    {
        clearstatcache(false, $path);

        if (!file_exists($path)) {
            throw new FileInfoException("$path does not exist");
        }

        $stat = stat($path);
        $file = new FileInfo();

        $file->setPath($path);
        $file->setIsdir(is_dir($path));
        $file->setMode(fileperms($path));
        $file->setOwner(fileowner($path));
        $file->setGroup(filegroup($path));
        $file->setSize(filesize($path));
        $file->setUid($stat['uid']);
        $file->setGid($stat['gid']);
        $file->setMtime($stat['mtime']);

        if ($as) {
            $file->setPath($as);
        }

        return $file;
    }

    /**
     * @return int the filesize. always 0 for directories
     */
    public function getSize()
    {
        if($this->isdir) return 0;
        return $this->size;
    }

    /**
     * @param int $size
     */
    public function setSize($size)
    {
        $this->size = $size;
    }

    /**
     * @return int
     */
    public function getCompressedSize()
    {
        return $this->csize;
    }

    /**
     * @param int $csize
     */
    public function setCompressedSize($csize)
    {
        $this->csize = $csize;
    }

    /**
     * @return int
     */
    public function getMtime()
    {
        return $this->mtime;
    }

    /**
     * @param int $mtime
     */
    public function setMtime($mtime)
    {
        $this->mtime = $mtime;
    }

    /**
     * @return int
     */
    public function getGid()
    {
        return $this->gid;
    }

    /**
     * @param int $gid
     */
    public function setGid($gid)
    {
        $this->gid = $gid;
    }

    /**
     * @return int
     */
    public function getUid()
    {
        return $this->uid;
    }

    /**
     * @param int $uid
     */
    public function setUid($uid)
    {
        $this->uid = $uid;
    }

    /**
     * @return string
     */
    public function getComment()
    {
        return $this->comment;
    }

    /**
     * @param string $comment
     */
    public function setComment($comment)
    {
        $this->comment = $comment;
    }

    /**
     * @return string
     */
    public function getGroup()
    {
        return $this->group;
    }

    /**
     * @param string $group
     */
    public function setGroup($group)
    {
        $this->group = $group;
    }

    /**
     * @return boolean
     */
    public function getIsdir()
    {
        return $this->isdir;
    }

    /**
     * @param boolean $isdir
     */
    public function setIsdir($isdir)
    {
        // default mode for directories
        if ($isdir && $this->mode === 0664) {
            $this->mode = 0775;
        }
        $this->isdir = $isdir;
    }

    /**
     * @return int
     */
    public function getMode()
    {
        return $this->mode;
    }

    /**
     * @param int $mode
     */
    public function setMode($mode)
    {
        $this->mode = $mode;
    }

    /**
     * @return string
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * @param string $owner
     */
    public function setOwner($owner)
    {
        $this->owner = $owner;
    }

    /**
     * @return string
     */
    public function getPath()
    {
        return $this->path;
    }

    /**
     * @param string $path
     */
    public function setPath($path)
    {
        $this->path = $this->cleanPath($path);
    }

    /**
     * Cleans up a path and removes relative parts, also strips leading slashes
     *
     * @param string $path
     * @return string
     */
    protected function cleanPath($path)
    {
        $path    = str_replace('\\', '/', $path);
        $path    = explode('/', $path);
        $newpath = array();
        foreach ($path as $p) {
            if ($p === '' || $p === '.') {
                continue;
            }
            if ($p === '..') {
                array_pop($newpath);
                continue;
            }
            array_push($newpath, $p);
        }
        return trim(implode('/', $newpath), '/');
    }

    /**
     * Strip given prefix or number of path segments from the filename
     *
     * The $strip parameter allows you to strip a certain number of path components from the filenames
     * found in the tar file, similar to the --strip-components feature of GNU tar. This is triggered when
     * an integer is passed as $strip.
     * Alternatively a fixed string prefix may be passed in $strip. If the filename matches this prefix,
     * the prefix will be stripped. It is recommended to give prefixes with a trailing slash.
     *
     * @param  int|string $strip
     */
    public function strip($strip)
    {
        $filename = $this->getPath();
        $striplen = strlen($strip);
        if (is_int($strip)) {
            // if $strip is an integer we strip this many path components
            $parts = explode('/', $filename);
            if (!$this->getIsdir()) {
                $base = array_pop($parts); // keep filename itself
            } else {
                $base = '';
            }
            $filename = join('/', array_slice($parts, $strip));
            if ($base) {
                $filename .= "/$base";
            }
        } else {
            // if strip is a string, we strip a prefix here
            if (substr($filename, 0, $striplen) == $strip) {
                $filename = substr($filename, $striplen);
            }
        }

        $this->setPath($filename);
    }

    /**
     * Does the file match the given include and exclude expressions?
     *
     * Exclude rules take precedence over include rules
     *
     * @param string $include Regular expression of files to include
     * @param string $exclude Regular expression of files to exclude
     * @return bool
     */
    public function matchExpression($include = '', $exclude = '')
    {
        $extract = true;
        if ($include && !preg_match($include, $this->getPath())) {
            $extract = false;
        }
        if ($exclude && preg_match($exclude, $this->getPath())) {
            $extract = false;
        }

        return $extract;
    }
}


/**
 * File meta data problems
 */
class FileInfoException extends \Exception
{
}


/**
 * Class Tar
 *
 * Creates or extracts Tar archives. Supports gz and bzip compression
 *
 * Long pathnames (>100 chars) are supported in POSIX ustar and GNU longlink formats.
 *
 * @author  Andreas Gohr <andi@splitbrain.org>
 * @package splitbrain\PHPArchive
 * @license MIT
 */
class Tar extends Archive
{

    protected $file = '';
    protected $comptype = Archive::COMPRESS_AUTO;
    protected $complevel = 9;
    protected $fh;
    protected $memory = '';
    protected $closed = true;
    protected $writeaccess = false;

    /**
     * Sets the compression to use
     *
     * @param int $level Compression level (0 to 9)
     * @param int $type Type of compression to use (use COMPRESS_* constants)
     * @throws ArchiveIllegalCompressionException
     */
    public function setCompression($level = 9, $type = Archive::COMPRESS_AUTO)
    {
        $this->compressioncheck($type);
        if ($level < -1 || $level > 9) {
            throw new ArchiveIllegalCompressionException('Compression level should be between -1 and 9');
        }
        $this->comptype  = $type;
        $this->complevel = $level;
        if($level == 0) $this->comptype = Archive::COMPRESS_NONE;
        if($type == Archive::COMPRESS_NONE) $this->complevel = 0;
    }

    /**
     * Open an existing TAR file for reading
     *
     * @param string $file
     * @throws ArchiveIOException
     * @throws ArchiveIllegalCompressionException
     */
    public function open($file)
    {
        $this->file = $file;

        // update compression to mach file
        if ($this->comptype == Tar::COMPRESS_AUTO) {
            $this->setCompression($this->complevel, $this->filetype($file));
        }

        // open file handles
        if ($this->comptype === Archive::COMPRESS_GZIP) {
            $this->fh = @gzopen($this->file, 'rb');
        } elseif ($this->comptype === Archive::COMPRESS_BZIP) {
            $this->fh = @bzopen($this->file, 'r');
        } else {
            $this->fh = @fopen($this->file, 'rb');
        }

        if (!$this->fh) {
            throw new ArchiveIOException('Could not open file for reading: '.$this->file);
        }
        $this->closed = false;
    }

    /**
     * Read the contents of a TAR archive
     *
     * This function lists the files stored in the archive
     *
     * The archive is closed afer reading the contents, because rewinding is not possible in bzip2 streams.
     * Reopen the file with open() again if you want to do additional operations
     *
     * @throws ArchiveIOException
     * @throws ArchiveCorruptedException
     * @returns FileInfo[]
     */
    public function contents()
    {
        if ($this->closed || !$this->file) {
            throw new ArchiveIOException('Can not read from a closed archive');
        }

        $result = array();
        while ($read = $this->readbytes(512)) {
            $header = $this->parseHeader($read);
            if (!is_array($header)) {
                continue;
            }

            $this->skipbytes(ceil($header['size'] / 512) * 512);
            $result[] = $this->header2fileinfo($header);
        }

        $this->close();
        return $result;
    }

    /**
     * Extract an existing TAR archive
     *
     * The $strip parameter allows you to strip a certain number of path components from the filenames
     * found in the tar file, similar to the --strip-components feature of GNU tar. This is triggered when
     * an integer is passed as $strip.
     * Alternatively a fixed string prefix may be passed in $strip. If the filename matches this prefix,
     * the prefix will be stripped. It is recommended to give prefixes with a trailing slash.
     *
     * By default this will extract all files found in the archive. You can restrict the output using the $include
     * and $exclude parameter. Both expect a full regular expression (including delimiters and modifiers). If
     * $include is set only files that match this expression will be extracted. Files that match the $exclude
     * expression will never be extracted. Both parameters can be used in combination. Expressions are matched against
     * stripped filenames as described above.
     *
     * The archive is closed afer reading the contents, because rewinding is not possible in bzip2 streams.
     * Reopen the file with open() again if you want to do additional operations
     *
     * @param string $outdir the target directory for extracting
     * @param int|string $strip either the number of path components or a fixed prefix to strip
     * @param string $exclude a regular expression of files to exclude
     * @param string $include a regular expression of files to include
     * @throws ArchiveIOException
     * @throws ArchiveCorruptedException
     * @return FileInfo[]
     */
    public function extract($outdir, $strip = '', $exclude = '', $include = '')
    {
        if ($this->closed || !$this->file) {
            throw new ArchiveIOException('Can not read from a closed archive');
        }

        $outdir = rtrim($outdir, '/');
        if (!file_exists($outdir)) @mkdir($outdir, 0777, true);
        if (!is_dir($outdir)) {
            throw new ArchiveIOException("Could not create directory '$outdir'");
        }

        $extracted = array();
        while ($dat = $this->readbytes(512)) {
            // read the file header
            $header = $this->parseHeader($dat);
            if (!is_array($header)) {
                continue;
            }
            $fileinfo = $this->header2fileinfo($header);

            // apply strip rules
            $fileinfo->strip($strip);

            // skip unwanted files
            if (!strlen($fileinfo->getPath()) || !$fileinfo->matchExpression($include, $exclude)) {
                $this->skipbytes(ceil($header['size'] / 512) * 512);
                continue;
            }

            // create output directory
            $output    = $outdir.'/'.$fileinfo->getPath();
            $directory = ($fileinfo->getIsdir()) ? $output : dirname($output);
            if (!file_exists($directory)) @mkdir($directory, 0777, true);

            // extract data
            if (!$fileinfo->getIsdir()) {
                $fp = @fopen($output, "wb");
                if (!$fp) {
                    throw new ArchiveIOException('Could not open file for writing: '.$output);
                }

                $size = floor($header['size'] / 512);
                for ($i = 0; $i < $size; $i++) {
                    fwrite($fp, $this->readbytes(512), 512);
                }
                if (($header['size'] % 512) != 0) {
                    fwrite($fp, $this->readbytes(512), $header['size'] % 512);
                }

                fclose($fp);
                @touch($output, $fileinfo->getMtime());
                @chmod($output, $fileinfo->getMode());
            } else {
                $this->skipbytes(ceil($header['size'] / 512) * 512); // the size is usually 0 for directories
            }

            if(is_callable($this->callback)) {
                call_user_func($this->callback, $fileinfo);
            }
            $extracted[] = $fileinfo;
        }

        $this->close();
        return $extracted;
    }

    /**
     * Create a new TAR file
     *
     * If $file is empty, the tar file will be created in memory
     *
     * @param string $file
     * @throws ArchiveIOException
     * @throws ArchiveIllegalCompressionException
     */
    public function create($file = '')
    {
        $this->file   = $file;
        $this->memory = '';
        $this->fh     = 0;

        if ($this->file) {
            // determine compression
            if ($this->comptype == Archive::COMPRESS_AUTO) {
                $this->setCompression($this->complevel, $this->filetype($file));
            }

            if ($this->comptype === Archive::COMPRESS_GZIP) {
                $this->fh = @gzopen($this->file, 'wb'.$this->complevel);
            } elseif ($this->comptype === Archive::COMPRESS_BZIP) {
                $this->fh = @bzopen($this->file, 'w');
            } else {
                $this->fh = @fopen($this->file, 'wb');
            }

            if (!$this->fh) {
                throw new ArchiveIOException('Could not open file for writing: '.$this->file);
            }
        }
        $this->writeaccess = true;
        $this->closed      = false;
    }

    /**
     * Add a file to the current TAR archive using an existing file in the filesystem
     *
     * @param string $file path to the original file
     * @param string|FileInfo $fileinfo either the name to us in archive (string) or a FileInfo oject with all meta data, empty to take from original
     * @throws ArchiveCorruptedException when the file changes while reading it, the archive will be corrupt and should be deleted
     * @throws ArchiveIOException there was trouble reading the given file, it was not added
     * @throws FileInfoException trouble reading file info, it was not added
     */
    public function addFile($file, $fileinfo = '')
    {
        if (is_string($fileinfo)) {
            $fileinfo = FileInfo::fromPath($file, $fileinfo);
        }

        if ($this->closed) {
            throw new ArchiveIOException('Archive has been closed, files can no longer be added');
        }

        // create file header
        $this->writeFileHeader($fileinfo);

        // write data, but only if we have data to write.
        // note: on Windows fopen() on a directory will fail, so we prevent
        // errors on Windows by testing if we have data to write.
        if (!$fileinfo->getIsdir() && $fileinfo->getSize() > 0) {
            $read = 0;
            $fp = @fopen($file, 'rb');
            if (!$fp) {
                throw new ArchiveIOException('Could not open file for reading: ' . $file);
            }
            while (!feof($fp)) {
                $data = fread($fp, 512);
                $read += strlen($data);
                if ($data === false) {
                    break;
                }
                if ($data === '') {
                    break;
                }
                $packed = pack("a512", $data);
                $this->writebytes($packed);
            }
            fclose($fp);

            if ($read != $fileinfo->getSize()) {
                $this->close();
                throw new ArchiveCorruptedException("The size of $file changed while reading, archive corrupted. read $read expected ".$fileinfo->getSize());
            }
        }

        if(is_callable($this->callback)) {
            call_user_func($this->callback, $fileinfo);
        }
    }

    /**
     * Add a file to the current TAR archive using the given $data as content
     *
     * @param string|FileInfo $fileinfo either the name to us in archive (string) or a FileInfo oject with all meta data
     * @param string          $data     binary content of the file to add
     * @throws ArchiveIOException
     */
    public function addData($fileinfo, $data)
    {
        if (is_string($fileinfo)) {
            $fileinfo = new FileInfo($fileinfo);
        }

        if ($this->closed) {
            throw new ArchiveIOException('Archive has been closed, files can no longer be added');
        }

        $len = strlen($data);
        $fileinfo->setSize($len);
        $this->writeFileHeader($fileinfo);

        for ($s = 0; $s < $len; $s += 512) {
            $this->writebytes(pack("a512", substr($data, $s, 512)));
        }

        if (is_callable($this->callback)) {
            call_user_func($this->callback, $fileinfo);
        }
    }

    /**
     * Add the closing footer to the archive if in write mode, close all file handles
     *
     * After a call to this function no more data can be added to the archive, for
     * read access no reading is allowed anymore
     *
     * "Physically, an archive consists of a series of file entries terminated by an end-of-archive entry, which
     * consists of two 512 blocks of zero bytes"
     *
     * @link http://www.gnu.org/software/tar/manual/html_chapter/tar_8.html#SEC134
     * @throws ArchiveIOException
     */
    public function close()
    {
        if ($this->closed) {
            return;
        } // we did this already

        // write footer
        if ($this->writeaccess) {
            $this->writebytes(pack("a512", ""));
            $this->writebytes(pack("a512", ""));
        }

        // close file handles
        if ($this->file) {
            if ($this->comptype === Archive::COMPRESS_GZIP) {
                gzclose($this->fh);
            } elseif ($this->comptype === Archive::COMPRESS_BZIP) {
                bzclose($this->fh);
            } else {
                fclose($this->fh);
            }

            $this->file = '';
            $this->fh   = 0;
        }

        $this->writeaccess = false;
        $this->closed      = true;
    }

    /**
     * Returns the created in-memory archive data
     *
     * This implicitly calls close() on the Archive
     * @throws ArchiveIOException
     */
    public function getArchive()
    {
        $this->close();

        if ($this->comptype === Archive::COMPRESS_AUTO) {
            $this->comptype = Archive::COMPRESS_NONE;
        }

        if ($this->comptype === Archive::COMPRESS_GZIP) {
            return gzencode($this->memory, $this->complevel);
        }
        if ($this->comptype === Archive::COMPRESS_BZIP) {
            return bzcompress($this->memory);
        }
        return $this->memory;
    }

    /**
     * Save the created in-memory archive data
     *
     * Note: It more memory effective to specify the filename in the create() function and
     * let the library work on the new file directly.
     *
     * @param string $file
     * @throws ArchiveIOException
     * @throws ArchiveIllegalCompressionException
     */
    public function save($file)
    {
        if ($this->comptype === Archive::COMPRESS_AUTO) {
            $this->setCompression($this->complevel, $this->filetype($file));
        }

        if (!@file_put_contents($file, $this->getArchive())) {
            throw new ArchiveIOException('Could not write to file: '.$file);
        }
    }

    /**
     * Read from the open file pointer
     *
     * @param int $length bytes to read
     * @return string
     */
    protected function readbytes($length)
    {
        if ($this->comptype === Archive::COMPRESS_GZIP) {
            return @gzread($this->fh, $length);
        } elseif ($this->comptype === Archive::COMPRESS_BZIP) {
            return @bzread($this->fh, $length);
        } else {
            return @fread($this->fh, $length);
        }
    }

    /**
     * Write to the open filepointer or memory
     *
     * @param string $data
     * @throws ArchiveIOException
     * @return int number of bytes written
     */
    protected function writebytes($data)
    {
        if (!$this->file) {
            $this->memory .= $data;
            $written = strlen($data);
        } elseif ($this->comptype === Archive::COMPRESS_GZIP) {
            $written = @gzwrite($this->fh, $data);
        } elseif ($this->comptype === Archive::COMPRESS_BZIP) {
            $written = @bzwrite($this->fh, $data);
        } else {
            $written = @fwrite($this->fh, $data);
        }
        if ($written === false) {
            throw new ArchiveIOException('Failed to write to archive stream');
        }
        return $written;
    }

    /**
     * Skip forward in the open file pointer
     *
     * This is basically a wrapper around seek() (and a workaround for bzip2)
     *
     * @param int $bytes seek to this position
     */
    protected function skipbytes($bytes)
    {
        if ($this->comptype === Archive::COMPRESS_GZIP) {
            @gzseek($this->fh, $bytes, SEEK_CUR);
        } elseif ($this->comptype === Archive::COMPRESS_BZIP) {
            // there is no seek in bzip2, we simply read on
            // bzread allows to read a max of 8kb at once
            while($bytes) {
                $toread = min(8192, $bytes);
                @bzread($this->fh, $toread);
                $bytes -= $toread;
            }
        } else {
            @fseek($this->fh, $bytes, SEEK_CUR);
        }
    }

    /**
     * Write the given file meta data as header
     *
     * @param FileInfo $fileinfo
     * @throws ArchiveIOException
     */
    protected function writeFileHeader(FileInfo $fileinfo)
    {
        $this->writeRawFileHeader(
            $fileinfo->getPath(),
            $fileinfo->getUid(),
            $fileinfo->getGid(),
            $fileinfo->getMode(),
            $fileinfo->getSize(),
            $fileinfo->getMtime(),
            $fileinfo->getIsdir() ? '5' : '0'
        );
    }

    /**
     * Write a file header to the stream
     *
     * @param string $name
     * @param int $uid
     * @param int $gid
     * @param int $perm
     * @param int $size
     * @param int $mtime
     * @param string $typeflag Set to '5' for directories
     * @throws ArchiveIOException
     */
    protected function writeRawFileHeader($name, $uid, $gid, $perm, $size, $mtime, $typeflag = '')
    {
        // handle filename length restrictions
        $prefix  = '';
        $namelen = strlen($name);
        if ($namelen > 100) {
            $file = basename($name);
            $dir  = dirname($name);
            if (strlen($file) > 100 || strlen($dir) > 155) {
                // we're still too large, let's use GNU longlink
                $this->writeRawFileHeader('././@LongLink', 0, 0, 0, $namelen, 0, 'L');
                for ($s = 0; $s < $namelen; $s += 512) {
                    $this->writebytes(pack("a512", substr($name, $s, 512)));
                }
                $name = substr($name, 0, 100); // cut off name
            } else {
                // we're fine when splitting, use POSIX ustar
                $prefix = $dir;
                $name   = $file;
            }
        }

        // values are needed in octal
        $uid   = sprintf("%6s ", decoct($uid));
        $gid   = sprintf("%6s ", decoct($gid));
        $perm  = sprintf("%6s ", decoct($perm));
        $size  = sprintf("%11s ", decoct($size));
        $mtime = sprintf("%11s", decoct($mtime));

        $data_first = pack("a100a8a8a8a12A12", $name, $perm, $uid, $gid, $size, $mtime);
        $data_last  = pack("a1a100a6a2a32a32a8a8a155a12", $typeflag, '', 'ustar', '', '', '', '', '', $prefix, "");

        for ($i = 0, $chks = 0; $i < 148; $i++) {
            $chks += ord($data_first[$i]);
        }

        for ($i = 156, $chks += 256, $j = 0; $i < 512; $i++, $j++) {
            $chks += ord($data_last[$j]);
        }

        $this->writebytes($data_first);

        $chks = pack("a8", sprintf("%6s ", decoct($chks)));
        $this->writebytes($chks.$data_last);
    }

    /**
     * Decode the given tar file header
     *
     * @param string $block a 512 byte block containing the header data
     * @return array|false returns false when this was a null block
     * @throws ArchiveCorruptedException
     */
    protected function parseHeader($block)
    {
        if (!$block || strlen($block) != 512) {
            throw new ArchiveCorruptedException('Unexpected length of header');
        }

        // null byte blocks are ignored
        if(trim($block) === '') return false;

        for ($i = 0, $chks = 0; $i < 148; $i++) {
            $chks += ord($block[$i]);
        }

        for ($i = 156, $chks += 256; $i < 512; $i++) {
            $chks += ord($block[$i]);
        }

        $header = @unpack(
            "a100filename/a8perm/a8uid/a8gid/a12size/a12mtime/a8checksum/a1typeflag/a100link/a6magic/a2version/a32uname/a32gname/a8devmajor/a8devminor/a155prefix",
            $block
        );
        if (!$header) {
            throw new ArchiveCorruptedException('Failed to parse header');
        }

        $return['checksum'] = OctDec(trim($header['checksum']));
        if ($return['checksum'] != $chks) {
            throw new ArchiveCorruptedException('Header does not match its checksum');
        }

        $return['filename'] = trim($header['filename']);
        $return['perm']     = OctDec(trim($header['perm']));
        $return['uid']      = OctDec(trim($header['uid']));
        $return['gid']      = OctDec(trim($header['gid']));
        $return['size']     = OctDec(trim($header['size']));
        $return['mtime']    = OctDec(trim($header['mtime']));
        $return['typeflag'] = $header['typeflag'];
        $return['link']     = trim($header['link']);
        $return['uname']    = trim($header['uname']);
        $return['gname']    = trim($header['gname']);

        // Handle ustar Posix compliant path prefixes
        if (trim($header['prefix'])) {
            $return['filename'] = trim($header['prefix']).'/'.$return['filename'];
        }

        // Handle Long-Link entries from GNU Tar
        if ($return['typeflag'] == 'L') {
            // following data block(s) is the filename
            $filename = trim($this->readbytes(ceil($return['size'] / 512) * 512));
            // next block is the real header
            $block  = $this->readbytes(512);
            $return = $this->parseHeader($block);
            // overwrite the filename
            $return['filename'] = $filename;
        }

        return $return;
    }

    /**
     * Creates a FileInfo object from the given parsed header
     *
     * @param $header
     * @return FileInfo
     */
    protected function header2fileinfo($header)
    {
        $fileinfo = new FileInfo();
        $fileinfo->setPath($header['filename']);
        $fileinfo->setMode($header['perm']);
        $fileinfo->setUid($header['uid']);
        $fileinfo->setGid($header['gid']);
        $fileinfo->setSize($header['size']);
        $fileinfo->setMtime($header['mtime']);
        $fileinfo->setOwner($header['uname']);
        $fileinfo->setGroup($header['gname']);
        $fileinfo->setIsdir((bool) $header['typeflag']);

        return $fileinfo;
    }

    /**
     * Checks if the given compression type is available and throws an exception if not
     *
     * @param $comptype
     * @throws ArchiveIllegalCompressionException
     */
    protected function compressioncheck($comptype)
    {
        if ($comptype === Archive::COMPRESS_GZIP && !function_exists('gzopen')) {
            throw new ArchiveIllegalCompressionException('No gzip support available');
        }

        if ($comptype === Archive::COMPRESS_BZIP && !function_exists('bzopen')) {
            throw new ArchiveIllegalCompressionException('No bzip2 support available');
        }
    }

    /**
     * Guesses the wanted compression from the given file
     *
     * Uses magic bytes for existing files, the file extension otherwise
     *
     * You don't need to call this yourself. It's used when you pass Archive::COMPRESS_AUTO somewhere
     *
     * @param string $file
     * @return int
     */
    public function filetype($file)
    {
        // for existing files, try to read the magic bytes
        if(file_exists($file) && is_readable($file) && filesize($file) > 5) {
            $fh = @fopen($file, 'rb');
            if(!$fh) return false;
            $magic = fread($fh, 5);
            fclose($fh);

            if(strpos($magic, "\x42\x5a") === 0) return Archive::COMPRESS_BZIP;
            if(strpos($magic, "\x1f\x8b") === 0) return Archive::COMPRESS_GZIP;
        }

        // otherwise rely on file name
        $file = strtolower($file);
        if (substr($file, -3) == '.gz' || substr($file, -4) == '.tgz') {
            return Archive::COMPRESS_GZIP;
        } elseif (substr($file, -4) == '.bz2' || substr($file, -4) == '.tbz') {
            return Archive::COMPRESS_BZIP;
        }

        return Archive::COMPRESS_NONE;
    }

}

?>